mpgrafic - MPI version of Ed Bertschinger initial conditions grafic package

Copyright (C) 2008-2020 by Simon Prunet, Christophe Pichon, Boud Roukema
prunet iap.fr

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the
Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

You should be able to compile with

./configure && make

and you will then find the executable

src/mpgrafic

See Input.stdin as an example input file, otherwise run mpgrafic
interactively. (The output to terminal should match the file
Output.stdout.np32 .)

If ./configure fails, then autotools should work. Try instead:

autoconf && ./configure && make

or

autoreconf && ./configure && make

See http://www2.iap.fr/users/pichon/mpgrafic.html for documentation.

A git development version is available at http://bitbucket.org/broukema/mpgrafic .

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!   wrap_gsl_rng_mod - fortran wrapper for bits of GNU Scientific Library !
!                                                                         !
!   Copyright (C) 2016-2019 by Boud Roukema                               !
!   boud cosmo.torun.pl                                                   !
!                                                                         !
!   This program is free software; you can redistribute it and/or modify  !
!   it under the terms of the GNU General Public License as published by  !
!   the Free Software Foundation; either version 2 of the License, or     !
!   (at your option) any later version.                                   !
!                                                                         !
!   This program is distributed in the hope that it will be useful,       !
!   but WITHOUT ANY WARRANTY; without even the implied warranty of        !
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         !
!   GNU General Public License for more details.                          !
!                                                                         !
!   You should have received a copy of the GNU General Public License     !
!   along with this program; if not, write to the                         !
!   Free Software Foundation, Inc.,                                       !
!   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA              !
!   or see https://www.gnu.org/licenses/licenses.html#GPL .               !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module wrap_gsl_rng_mod
  ! see e.g. https://stackoverflow.com/tags/fortran-iso-c-binding/info

  interface
     subroutine get_gsl_rng_seeds &
          (iseed, MaxRandNumStreams, seeds) &
          bind(C, name='get_gsl_rng_seeds')
       use iso_C_binding
       implicit none
       ! INPUTS
       integer (c_int64_t), value :: iseed
       integer (c_int32_t), value :: MaxRandNumStreams
       ! OUTPUT
       integer (c_int64_t), dimension(MaxRandNumStreams) :: seeds
     end subroutine get_gsl_rng_seeds
  end interface

  interface
     subroutine gauss_gsl &
          (Seed, RandNum, free_gauss_gsl) &
          bind(C, name='gauss_gsl')
       use iso_C_binding
       implicit none
       integer (c_int64_t), value :: Seed ! pass by value
       real (c_double) :: RandNum ! pass by reference
       integer (c_int), value :: free_gauss_gsl ! pass by value
     end subroutine gauss_gsl
  end interface

end module wrap_gsl_rng_mod

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!   Copyright (C) 2008-2019 by Simon Prunet, Christophe Pichon et al     !
!   prunet iap.fr                                                        !
!                                                                        !
!   This program is free software; you can redistribute it and/or modify !
!   it under the terms of the GNU General Public License as published by !
!   the Free Software Foundation; either version 2 of the License, or    !
!   (at your option) any later version.                                  !
!                                                                        !
!   This program is distributed in the hope that it will be useful,      !
!   but WITHOUT ANY WARRANTY; without even the implied warranty of       !
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        !
!   GNU General Public License for more details.                         !
!                                                                        !
!   You should have received a copy of the GNU General Public License    !
!   along with this program; if not, write to the                        !
!   Free Software Foundation, Inc.,                                      !
!     59 Temple Place - Suite 330, Boston, MA  02111-1307, USA           !
!   or see https://www.gnu.org/licenses/licenses.html#GPL .              !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        subroutine splder(y,dy,n)
!  Splder fits a cubic spline to y and returns the first derivatives at
!  the grid points in dy.  dy is equivalent to a 4th-order Pade
!  difference formula for dy/di.
!
        implicit double precision (a-h,o-z)
        dimension f(100001),gspl(100001),y(n),dy(n)
        common /spline/ gspl
!
        n1=n-1
        if (n1.gt.100000) &
     &    write(*,*) 'Spline array overflow!!! n1=',n1,'>100000'
!  Quartic fit to dy/di at boundaries, assuming d3y/di3=0.
        f(1)=(-10.0d0*y(1)+15.0d0*y(2)-6.0d0*y(3)+y(4))/6.0d0
        f(n)=(10.0d0*y(n)-15.0d0*y(n1)+6.0d0*y(n-2)-y(n-3))/6.0d0
!  Solve the tridiagonal system
!  dy(i-1)+4*dy(i)+dy(i+1)=3*(y(i+1)-y(i-1)), i=2,3,...,n1,
!  with dy(1)=f(1), dy(n)=f(n).
          do 10 i=2,n1
          f(i)=gspl(i)*(3.0d0*(y(i+1)-y(i-1))-f(i-1))
10      continue
        dy(n)=f(n)
          do 20 i=n1,1,-1
          dy(i)=f(i)-gspl(i)*dy(i+1)
20      continue
        return
        end
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        subroutine spintn(y,dy,z,n)
!  Spintn calculates z(i) = the integral from 1 to i of s(j)dj, for 1 <= i <= n,
!  where s is the spline fit to y, and dy = ds/di.
!
        implicit double precision (a-h,o-z)
        dimension y(n),dy(n),z(n)

        ztemp=0.0d0
          do 10 i=2,n
          ztemp1=ztemp+0.5d0*(y(i-1)+y(i))+(dy(i-1)-dy(i))/12.0d0
          z(i-1)=ztemp
          ztemp=ztemp1
10      continue
        z(n)=ztemp
        return
        end
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        subroutine splini
!  Splini must be called before splder to initialize array g in common.

        implicit double precision (a-h,o-z)
        dimension gspl(100001)
        common /spline/ gspl
        save /spline/
!
        gspl(1)=0.0d0
          do 10 i=2,100001
          gspl(i)=1.0d0/(4.0d0-gspl(i-1))
10      continue
        return
        end
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        subroutine matinv(a,n,np,y)
!  Invert the double precision nxn matrix a; physical dimensions are np x np.
!  Inverse is returned in y.  WARNING: a is destroyed!
        double precision a(np,np),y(np,np)
        parameter (nmax=1000)
        dimension indx(nmax)

        if (n.gt.nmax) then
          write(*,*) 'increase storage in ludcmp!  n,nmax=',n,nmax
        end if
          do 12 j=1,n
            do 11 i=1,n
            y(i,j)=0.0d0
11        continue
          y(j,j)=1.0d0
12      continue
        call ludcmp(a,n,np,indx)
          do 13 j=1,n
          call lubksb(a,n,np,indx,y(1,j))
13      continue
        return
        end

        subroutine ludcmp(a,n,np,indx)
        parameter (tiny=0.0d-20,nmax=1000)
        double precision a(np,np),sum,temp
        double precision aamax,vv(nmax)
        dimension indx(n)
        if (n.gt.nmax) then
          write(*,*) 'increase storage in ludcmp!  n,nmax=',n,nmax
        end if
          do 12 i=1,n
          aamax=0.0d0
          do 11 j=1,n
          if (abs(a(i,j)).gt.aamax) aamax=abs(a(i,j))
11        continue
          if(aamax.eq.0.d0)then
             write(6,*)'singular matrix.'
             stop
          endif
          vv(i)=1./aamax
12      continue
          do 19 j=1,n
          if (j.gt.1) then
              do 14 i=1,j-1
              sum=a(i,j)
              if (i.gt.1) then
                  do 13 k=1,i-1
                  sum=sum-a(i,k)*a(k,j)
13              continue
                a(i,j)=sum
              endif
14          continue
          endif
          aamax=0.0d0
            do 16 i=j,n
            sum=a(i,j)
            if (j.gt.1) then
                do 15 k=1,j-1
                sum=sum-a(i,k)*a(k,j)
15            continue
              a(i,j)=sum
            endif
            temp=vv(i)*abs(sum)
            if (temp.ge.aamax) then
              imax=i
              aamax=temp
            endif
16        continue
          if (j.ne.imax) then
              do 17 k=1,n
              temp=a(imax,k)
              a(imax,k)=a(j,k)
              a(j,k)=temp
17          continue
            vv(imax)=vv(j)
          endif
          indx(j)=imax
          if (j.ne.n) then
!           if (a(j,j).eq.0.d0) a(j,j)=tiny
            temp=1.0d0/a(j,j)
              do 18 i=j+1,n
              a(i,j)=a(i,j)*temp
18          continue
          endif
19      continue
!       if (a(n,n).eq.0.0d0) a(n,n)=tiny
        return
        end
!
        subroutine lubksb(a,n,np,indx,b)
        double precision a(np,np),b(np),sum
        dimension indx(n)
        ii=0
          do 12 i=1,n
          ll=indx(i)
          sum=b(ll)
          b(ll)=b(i)
          if (ii.ne.0) then
              do 11 j=ii,i-1
              sum=sum-a(i,j)*b(j)
11          continue
          else if (sum.ne.0.0d0) then
            ii=i
          endif
          b(i)=sum
12      continue
          do 14 i=n,1,-1
          sum=b(i)
          if (i.lt.n) then
              do 13 j=i+1,n
              sum=sum-a(i,j)*b(j)
13          continue
          endif
          b(i)=sum/a(i,i)
14      continue
        return
        end

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!   Copyright (C) 2008-2019 by Simon Prunet, Christophe Pichon et al     !
!   prunet iap.fr                                                        !
!   Copyright (C) 2020 Boud Roukema -  fix single vs double precision    !
!                                                                        !
!   This program is free software; you can redistribute it and/or modify !
!   it under the terms of the GNU General Public License as published by !
!   the Free Software Foundation; either version 2 of the License, or    !
!   (at your option) any later version.                                  !
!                                                                        !
!   This program is distributed in the hope that it will be useful,      !
!   but WITHOUT ANY WARRANTY; without even the implied warranty of       !
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        !
!   GNU General Public License for more details.                         !
!                                                                        !
!   You should have received a copy of the GNU General Public License    !
!   along with this program; if not, write to the                        !
!   Free Software Foundation, Inc.,                                      !
!     59 Temple Place - Suite 330, Boston, MA  02111-1307, USA           !
!   or see https://www.gnu.org/licenses/licenses.html#GPL .              !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module transform

  use grafic_types
  IMPLICIT NONE
#ifdef ADD1US
#define  rfftw3d_f77_create_plan  rfftw3d_f77_create_plan_
#define  rfftwnd_f77_destroy_plan rfftwnd_f77_destroy_plan_
#define  rfftwnd_f77_one_real_to_complex rfftwnd_f77_one_real_to_complex_
#define  rfftw3d_f77_mpi_create_plan  rfftw3d_f77_mpi_create_plan_
#define  rfftwnd_f77_mpi_destroy_plan rfftwnd_f77_mpi_destroy_plan_
#define  rfftwnd_f77_mpi rfftwnd_f77_mpi_
#define  rfftwnd_f77_mpi_local_sizes rfftwnd_f77_mpi_local_sizes_
#endif

  interface fft_mpi
     module procedure fft_mpi_double
  end interface

contains

  subroutine fft_forward(l,m,n,input,output)

    integer :: l,m,n
    real*8, dimension(l,m,n), intent(in) :: input
    complex*16, dimension(l/2+1,m,n), intent(out) :: output
    integer*8 :: plan

    call rfftw3d_f77_create_plan(plan,l,m,n,FFTW_REAL_TO_COMPLEX, &
         & FFTW_ESTIMATE)
    call rfftwnd_f77_one_real_to_complex(plan,input,output)
    call rfftwnd_f77_destroy_plan(plan)

  end subroutine fft_forward

  ! This covers both forward and backward ffts,
  ! depending on plan

  subroutine fft_mpi_double(plan,input,total_local_size)

    use iso_C_binding

    ! Arguments
    type(c_ptr) :: plan
    integer :: total_local_size
    real(dp), dimension(total_local_size) :: input

    ! Local variables
    !integer :: ierr,myid,status
    !real*4 :: tstart, tstop
    real*8, allocatable, dimension(:) :: work

    !allocate(work(total_local_size),stat=status)
    !if (status /= 0) then
    !   print*,'Could not allocate work for proc #',myid
    !   stop
    !endif
    allocate(work(1))
!!$    call rfftwnd_f77_mpi(plan,1,input,work, &
!!$         & 0,FFTW_TRANSPOSED_ORDER)
    call rfftwnd_f77_mpi(plan,1,input,work, &
         & 0,FFTW_NORMAL_ORDER) !0 to ignore work, 1 to use it
    deallocate(work)

  end subroutine fft_mpi_double

end module transform

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!   wrap_rfftw3d_mod - fortran wrapper for bits of fftw2                  !
!                                                                         !
!   Copyright (C) 2017-2019 by Boud Roukema                               !
!   boud cosmo.torun.pl                                                   !
!                                                                         !
!   This program is free software; you can redistribute it and/or modify  !
!   it under the terms of the GNU General Public License as published by  !
!   the Free Software Foundation; either version 2 of the License, or     !
!   (at your option) any later version.                                   !
!                                                                         !
!   This program is distributed in the hope that it will be useful,       !
!   but WITHOUT ANY WARRANTY; without even the implied warranty of        !
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         !
!   GNU General Public License for more details.                          !
!                                                                         !
!   You should have received a copy of the GNU General Public License     !
!   along with this program; if not, write to the                         !
!   Free Software Foundation, Inc.,                                       !
!   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA              !
!   or see https://www.gnu.org/licenses/licenses.html#GPL .               !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module wrap_rfftw3d_mod
  ! see e.g. https://stackoverflow.com/tags/fortran-iso-c-binding/info

  interface
     subroutine rfftw3d_f77_mpi_create_plan_c_wrap &
          (rfftwnd_mpi_plan, comm, &
          nx, ny, nz, idir, flags) &
          bind(C, name='rfftw3d_f77_mpi_create_plan_c_wrap')
       use iso_C_binding
#ifdef HAVE_USE_MPI_F08
       use mpi_f08
#endif
       implicit none
#ifndef HAVE_USE_MPI_F08
       include 'mpif.h'
#endif
       type (c_ptr) :: rfftwnd_mpi_plan
       /*
       C vs fortran communicator types are the reason
       for this extra wrapper. One implementation of
       the C communicator typedef is the following:

       /usr/lib/openmpi/include/mpi.h
       typedef struct ompi_communicator_t *MPI_Comm

       Here we bypass this, for programs in which
       only the MPI_COMM_WORLD communicator is needed.
       */
#ifdef HAVE_USE_MPI_F08
       type(MPI_Comm) :: comm ! dummy
#else
       integer :: comm ! dummy
#endif
       integer(c_int) :: nx, ny, nz
       integer(c_int) :: idir, flags
     end subroutine rfftw3d_f77_mpi_create_plan_c_wrap
  end interface

end module wrap_rfftw3d_mod

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!   Copyright (C) 2008-2019 by Simon Prunet, Christophe Pichon et al     !
!   prunet iap.fr                                                        !
!                                                                        !
!   This program is free software; you can redistribute it and/or modify !
!   it under the terms of the GNU General Public License as published by !
!   the Free Software Foundation; either version 2 of the License, or    !
!   (at your option) any later version.                                  !
!                                                                        !
!   This program is distributed in the hope that it will be useful,      !
!   but WITHOUT ANY WARRANTY; without even the implied warranty of       !
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        !
!   GNU General Public License for more details.                         !
!                                                                        !
!   You should have received a copy of the GNU General Public License    !
!   along with this program; if not, write to the                        !
!   Free Software Foundation, Inc.,                                      !
!     59 Temple Place - Suite 330, Boston, MA  02111-1307, USA           !
!   or see https://www.gnu.org/licenses/licenses.html#GPL .              !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module normalize

  use grafic_types

contains

  subroutine mpnorm(local_nz,nz,ny,nx,total_local_size,buffer)

    ! Arguments
    integer, intent(in) :: local_nz,nz,ny,nx,total_local_size
#ifdef DOUB
    real(dp), dimension(total_local_size), intent(inout) :: buffer
#else
    real(sp), dimension(total_local_size), intent(inout) :: buffer
#endif

    ! Local variables
    integer :: myid, nproc, ierr
    real(dp) :: lmean, lstdev
    integer :: i1,i2,i3
    integer(i8b) :: index
    integer :: n2x
    real(dp) :: mean, stdev

    call mpi_comm_rank(mpi_comm_world,myid,ierr)
    call mpi_comm_size(mpi_comm_world,nproc,ierr)

    n2x = 2*(nx/2+1)

    lmean=0
    do i3=1,local_nz
       do i2=1,ny
          do i1=1,nx ! Real space, ignore padding zone
             index=int((i3-1)*ny+i2-1,8)*n2x+i1
#ifdef DOUB
             lmean = lmean+buffer(index)
#else
             lmean = lmean+real(buffer(index),kind=dp)
#endif
          enddo
       enddo
    enddo

    call mpi_allreduce(lmean,mean,1,mpi_double_precision,mpi_sum,mpi_comm_world,ierr)
    mean = mean/real(int(nx*ny,8)*nz,kind=dp)

    if (myid==0) then
       write(*,'(a,es15.5)') 'Mean value of the white noise box = ',mean
       print*,'Will be removed'
    endif

    lstdev=0
    do i3=1,local_nz
       do i2=1,ny
          do i1=1,nx ! Real space, skip padding zone
             index=int((i3-1)*ny+i2-1,8)*n2x+i1
#ifdef DOUB
             buffer(index) = buffer(index)-mean
             lstdev = lstdev+buffer(index)**2
#else
             buffer(index) = buffer(index)-real(mean,kind=sp)
             lstdev = lstdev + real(buffer(index),kind=8)**2
#endif
          enddo
       enddo
    enddo

    call mpi_allreduce(lstdev,stdev,1,mpi_double_precision,mpi_sum,mpi_comm_world,ierr)
    stdev = stdev/real(int(nx*ny,8)*nz,kind=dp)
    stdev = sqrt(stdev)
    if (myid==0) then
       write(*,'(a,f15.5)') 'Standard deviation of the white noise box = ',stdev
       print*,'Will be factored out so that input stdev=1'
    endif

#ifdef DOUB
    buffer = buffer/stdev
#else
    buffer = buffer/real(stdev,kind=sp)
#endif


  end subroutine mpnorm

end module normalize

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!   mpgrafic - MPI version of N-body initial conditions grafic package   !
!   Copyright (C) 2008-2019 by Simon Prunet, Christophe Pichon et al     !
!   prunet iap.fr                                                        !
!                                                                        !
!   This program is free software; you can redistribute it and/or modify !
!   it under the terms of the GNU General Public License as published by !
!   the Free Software Foundation; either version 2 of the License, or    !
!   (at your option) any later version.                                  !
!                                                                        !
!   This program is distributed in the hope that it will be useful,      !
!   but WITHOUT ANY WARRANTY; without even the implied warranty of       !
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        !
!   GNU General Public License for more details.                         !
!                                                                        !
!   You should have received a copy of the GNU General Public License    !
!   along with this program; if not, write to the                        !
!   Free Software Foundation, Inc.,                                      !
!     59 Temple Place - Suite 330, Boston, MA  02111-1307, USA           !
!   or see https://www.gnu.org/licenses/licenses.html#GPL .              !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
#include "../config.h"

program grafic1
  !  Generate initial conditions for cosmological N-body integration
  !  as a Gaussian random field.
  !  This version does not do constraints.  Instead, it produces output
  !  compatible with grafic2 for multiscale initial conditions.
  !  Disk use: lun=10 is output file, lun=11 is temp files.
  !
  use grafic_types
  use transform
  use grafic_io
  use normalize

  use iso_C_binding
  use wrap_rfftw3d_mod


  implicit none
#include "grafic1.inc"
#ifdef ADD1US
#define  rfftw3d_f77_create_plan  rfftw3d_f77_create_plan_
#define  rfftwnd_f77_destroy_plan rfftwnd_f77_destroy_plan_
#define  rfftwnd_f77_one_real_to_complex rfftwnd_f77_one_real_to_complex_
  /*
  mpgrafic-0.3.10 - shifted this routine to interface with iso_C_binding;
  #define  rfftw3d_f77_mpi_create_plan  rfftw3d_f77_mpi_create_plan_
  */
#define  rfftwnd_f77_mpi_destroy_plan rfftwnd_f77_mpi_destroy_plan_
#define  rfftwnd_f77_mpi rfftwnd_f77_mpi_
#define  rfftwnd_f77_mpi_local_sizes rfftwnd_f77_mpi_local_sizes_
#endif

  !c
  !c  Top grid size. This means the number of particles that
  !c  are to be placed at approximately regular intervals in the
  !c  1st, 2nd or 3rd orthogonal direction in the simulation box.
  !c  The total number of particles will be np1*np2*np3. Mpgrafic
  !c  normally outputs only the peculiar velocities of these particles;
  !c  the time evolution program should set particle positions
  !c  consistent with the Zel'dovich approximation.
  !c
  ! Can be overridden at ./configure stage, e.g.:
  ! CFLAGS="${CFLAGS} -DMPGRAFIC_NP_DEFAULT=1024" ./configure
#ifndef MPGRAFIC_NP_DEFAULT
#define MPGRAFIC_NP_DEFAULT 256
#endif

  integer :: np1 = MPGRAFIC_NP_DEFAULT
  integer :: np2 = MPGRAFIC_NP_DEFAULT
  integer :: np3 = MPGRAFIC_NP_DEFAULT
  integer io_status

#ifdef SING
  real(sp), dimension(:), allocatable :: f
#else
  real(dp), dimension(:), allocatable :: f
#endif
  real dx,x1o,x2o,x3o,xoff,fm
  integer irand,itide,m1s,m2s,m3s !,m1off,m2off,m3off
#ifdef HAVE_LIBGSL
  integer (c_int64_t) iseed
#else
  integer iseed
#endif
  integer m1t,m2t,m3t,m1offt,m2offt,m3offt
  !integer i1,i2,i3, l1,l2,l3, m1,m2,m3
  integer icomp,idim,nrefine
  integer ipad, nxs, nys, nzs
#ifdef HAVE_LIBGSL
  integer (c_int64_t) iseeds
#else
  integer iseeds
#endif
  !double precision lsigma
  double precision twopi,sigma,dsigma,rombin !,sigmadispl
  double precision dsigmadispl
  parameter (twopi=6.283185307179586d0)
  logical hanning

  ! The input parameter file can be named in the command line or piped from standard input.
#ifdef f2003
  use, intrinsic :: iso_fortran_env, only : input_unit
#else
#  define input_unit 5
#endif
  character(len=256) :: input_param_file
  integer :: input_param_file_id = 15
  integer :: infile_id = input_unit   ! By default, read from standard input.

  character(len=128) :: filename, small_file_name, small_kfile_name
  real astart,omegam,omegav,h0,dladt,fomega,vfact,pbar,pcdm
  real omegab,omegahdm,degen_hdm
  real asig,dxr,dpls,dplus,adp
  integer ierr, myid, status
  type(c_ptr) :: plan, iplan
  integer :: local_z_start,local_nz,local_y_start,local_ny
  integer :: nx, ny, nz
  integer :: total_local_size
  integer :: local_z_starts, local_nzs, local_y_starts, local_nys, total_local_sizes
  type(taille) :: headt, shtaille
  type(cosmo) :: headc, shcosmo
  character(len=128) :: outputfile

  character(len=256) :: command_line_arg1 ! so far very limited options
  character(len=256) :: command_line_arg2 ! so far very limited options
  logical :: help_only_arg = .false.

  common /cosmoparms/ omegam,omegav,h0
  common /cosmoparms2/ omegab,omegahdm,degen_hdm
  common /dsig/ asig,dxr
  external pbar,pcdm,dsigma,dsigmadispl,rombin,dplus,adp

  one_command_line_argument: if(command_argument_count() .gt. 0)then
     call get_command_argument(1,command_line_arg1)
     command_line_arg1 = trim(command_line_arg1)
     ! TODO: this is a minimal hack - consider the GNU argp library for more general options
     if(command_line_arg1 == '-V' .or. &
          command_line_arg1 == '--version')then
        help_only_arg = .true.
        write(*,'(a)')PACKAGE_STRING
        write(*,'(a)')'Written by Simon Prunet, Christophe Pichon et al.'
        write(*,'(a)')''
        write(*,'(a)')'Copyright (C) 2008-2019 Prunet, Pichon, Roukema.'
        write(*,'(a)')'This program is free software; you may redistribute it under the terms of'
        write(*,'(a)')'the GNU General Public License version 2 or later.  This program has'
        write(*,'(a)')'absolutely no warranty.'
     elseif(command_line_arg1 == '-h' .or. &
          command_line_arg1 == '-?' .or. &
          command_line_arg1 == '--help')then
        help_only_arg = .true.
        ! TODO: modularise this out to a documentation type file
        write(*,'(a)')'Usage: mpgrafic [OPTION...] [[<] INPUT_FILE] [> OUTPUT_FILE]'
        write(*,'(a)')''
        write(*,'(a)')'mpgrafic produces initial conditions files for N-body simulations of'
        write(*,'(a)')'cosmological large-scale structure formation. It is a free-licensed,'
        write(*,'(a)')"MPI-parallelised, rewritten version of Ed Bertschinger's grafic-1"
        write(*,'(a)')'program, producing output files in the grafic format. It includes'
        write(*,'(a)')'options for an Eisenstein and Hu baryonic wiggles power spectrum, for'
        write(*,'(a)')'using a low-resolution map for large-scale modes in the spirit of'
        write(*,'(a)')'grafic-2, and together with constrfield, can be used for generating'
        write(*,'(a)')'constrained initial conditions. Details are given in Prunet et al'
        write(*,'(a)')'(2008) http://cdsads.u-strasbg.fr/abs/2008ApJS..178..179P.'
        write(*,'(a)')''
        write(*,'(a)')'Most recent source code:'
        write(*,'(a)')'git clone https://broukema@bitbucket.org/broukema/mpgrafic.git'
        write(*,'(a)')''
        write(*,'(a)')' -?, --help        Give this help list'
        write(*,'(a)')'     --np=INTEGER  Number of particles per dimension (grid size will be INTEGER^3)'
        write(*,'(a)')'     --usage       Give a short usage message'
        write(*,'(a)')' -V, --version     Print program version'
     elseif(command_line_arg1 == '--usage')then
        help_only_arg = .true.
        write(*,'(a)')'Usage: mpgrafic [-?hV] [--np=INTEGER] [--help] [--usage]'
        write(*,'(a)')'            [--version] [[<] INPUT_FILE] [> OUTPUT_FILE]'
     elseif( command_line_arg1(1:5) == '--np=' .and. &
          len(command_line_arg1) .gt. 5 )then
        read(command_line_arg1(6:len(command_line_arg1)), &
             *,iostat=io_status) np1 ! allows 10^30-particle simulations...
        if(io_status.eq.0)then !override configured value
           np2 = np1
           np3 = np1
        else
           write(*,'(a)')'Warning: error reading option --np.'
        endif
     elseif( .not.(command_line_arg1(1:1) == '-') .and. &
          len(command_line_arg1) .gt. 0 )then
        ! assume that this is a filename
        input_param_file = trim(command_line_arg1)
        infile_id = input_param_file_id
     endif
     if(help_only_arg)then ! if valid command line argument found
        stop ! user only wants to know how to get started
     endif
  endif one_command_line_argument

  second_command_line_argument: if(command_argument_count() .gt. 1)then
     call get_command_argument(2,command_line_arg2)
     command_line_arg2 = trim(command_line_arg2)
     if( .not. (infile_id == input_param_file_id) .and. & ! if filename not yet found
          .not.(command_line_arg2(1:1) == '-') .and. & ! refuse filenames starting with '-'
          len(command_line_arg2) .gt. 0 )then ! refuse zero-length filenames
        ! assume that this is a filename
        input_param_file = trim(command_line_arg2)
        infile_id = input_param_file_id
     endif
  endif second_command_line_argument

  !
  call mpi_init(ierr)
  call mpi_comm_rank(mpi_comm_world,myid,ierr)
  if (myid==0) then
     print*
     print*,'Will generate initial conditions on grid of size ', &
          &     np1,np2,np3
     print*
  endif

  ! We follow grafic conventions: slowest varying index is nz
  ! The domain decomposition will be done in this direction
  nx=np1
  ny=np2
  nz=np3

  if (myid==0) then
     ! open file if stdin not used
     if(infile_id == input_param_file_id)then
        open(infile_id, file=input_param_file, access='sequential',&
             status='old', form='formatted')

     endif
  endif

  !
  !  Initialize power spectrum.
  call pini(infile_id)
  !  Initialize grid spacing.
  if (myid==0) then
     print*,'Enter dx (initial particle spacing in Mpc, not Mpc/h)'
     print*,'   or enter -boxlength in Mpc/h'
     print*,'   i.e. dx in Mpc if > 0, or -boxlength in Mpc/h if < 0'
     read(infile_id,*) dx
     write(*,'(f15.5)') dx
  endif
  call mpi_bcast(dx,1,mpi_real,0,mpi_comm_world,ierr)
  if (dx.lt.0.0) then
     dx=-dx*100./(h0*nx)
     if (myid==0) write(*,'(a,f15.5,a)') '  dx=',dx,' Mpc'
  end if

  !  Set astart based on smallest grid spacing.
  if (myid==0) then
     print*,'Enter 1 if these initial conditions will not be ', &
          &    'refined, otherwise'
     print*,'  enter the ultimate refinement factor for the ', &
          &    'smallest grid spacing'
     print*,'  (This is used only to set astart.)'
     read(infile_id,*) nrefine
     print*, nrefine
  endif
  call mpi_bcast(nrefine,1,mpi_integer,0,mpi_comm_world,ierr)
  if (nrefine.lt.1) then
     if (myid==0) print*,'Error! refinement factor must be >= 1'
     call mpi_finalize(ierr)
     stop
  end if
  if (nrefine.gt.1) then
     if (myid==0) print*,'nrefine>1 not implemented yet'
     call mpi_finalize(ierr)
     stop
  end if
  dxr=dx/nrefine
  asig=1.0d0
  sigma=2.0*twopi*rombin(dsigma,0.0d0,0.5d0*twopi/dxr,1.0d-7)
  !  This is sigma at a=1.
  sigma=sqrt(sigma)

!!!!!!!! ALL following !!$ are to remove R. Teyssier's astart and
!!!!!!!! sigma computations....

!!$  sigmadispl=2.0*twopi* &
!!$       &     rombin(dsigmadispl,twopi/dxr/np1,0.5d0*twopi/dxr,1.0d-7)
  !  This is sigma at a=1.
!!$  sigmadispl=sqrt(sigmadispl)
!!$  sigma=MAX(sigma,sigmadispl/dxr)
  !  Normalize so that rms density flutuation=sigstart at starting
  !  redshift scaling back the fluctuations as if they grew like cdm.
  dpls=sigstart/sigma*dplus(1.0,omegam,omegav)
  astart=adp(dpls,omegam,omegav)
  asig=astart
  sigma=2.0*twopi*rombin(dsigma,0.0d0,0.5d0*twopi/dxr,1.0d-7)
!!$  sigma=2.0*twopi*rombin(dsigma,twopi/dxr/np1,0.5d0*twopi/ &
!!$       &                         dxr,1.0d-7)
  sigma=sqrt(sigma)
  if (myid==0) then
     write(*,'(a,es15.5)') 'Scaling initial conditions to starting a=',astart
     write(*,'(a,es15.5)') '  when sigma(delta) at ultimate refinement scale=' &
          &  ,real(sigma)
  endif
  !sigmadispl=2.0*twopi*rombin(dsigmadispl,0.0d0,0.5d0*twopi/dxr,1.0d-7)
!!$  sigmadispl=2.0*twopi* &
!!$       &   rombin(dsigmadispl,twopi/dxr/np1,0.5d0*twopi/dxr,1.0d-7)
!!$  sigmadispl=sqrt(sigmadispl)
!!$  if (myid==0) then
!!$     print*,'  when sigma(displ) at ultimate refinement scale=', &
!!$          &    real(sigmadispl),' Mpc '
!!$     print*,'                                                 ', &
!!$          &    real(sigmadispl)/dxr,' dx'
!!$     print*
!!$  endif

!!!!!!!! END OF astart/sigma modifications. Code should be back to
!!!!!!!! original grafic1 starting conditions....


  !  velocity (proper km/s) =  Displacement (comoving Mpc at astart) * vfact.
  !  vfact = dln(D+)/dtau where tau=conformal time.
  vfact=fomega(astart,omegam,omegav) &
       &       *h0*dladt(astart,omegam,omegav)/astart
  if (myid==0) write(*,'(a,es15.5)') 'vfact=',vfact
  !
  !  Now set output parameters.  There are two cases:
  !  hanning=T: no further refinement.
  !  hanning=F: prepare for further refinement.
  !
  if (myid==0) then
     print*,'Enter 0 for final output or 1 for further refinement'
     read(infile_id,*) irand
     print*, irand
  endif
  call mpi_barrier(mpi_comm_world,ierr)
  call mpi_bcast(irand,1,mpi_integer,0,mpi_comm_world,ierr)

  if (irand.eq.1) then
     if (myid==0) print*,'Further refinement (input to grafic2) not implemented yet'
     call mpi_finalize(ierr)
     stop
  endif

!!$  if (irand.eq.1) then
!!$     hanning=.false.
!!$     if (myid==0) print*,'Enter size (n1c,n2c,n3c) of the level-1 subgrid ', &
!!$          &      'to be extracted.'
!!$     if (myid==0) print*,'  Sizes must be even numbers and be no larger than ', &
!!$          &      int(0.5*np1),int(0.5*np2),int(0.5*np3)
!!$     read(*,*) m1s,m2s,m3s
!!$     if (mod(m1s,2).ne.0.or.mod(m2s,2).ne.0.or.mod(m3s,2).ne.0) then
!!$        if (myid==0) print*,'Error! Sizes must be even numbers!'
!!$        call mpi_finalize(ierr)
!!$        stop
!!$     end if
!!$     if (2*m1s.gt.np1.or.2*m2s.gt.np2.or.2*m3s.gt.np3) then
!!$        if (myid==0) print*,'Error!  Subgrid is too large'
!!$        call mpi_finalize(ierr)
!!$        stop
!!$     end if
!!$     if (myid==0) then
!!$        print*,'Enter offset of level-1 subgrid (m1off,m2off,m3off).'
!!$        print*,'  Offsets are relative to level-0 grid corner.'
!!$        print*,'  Offsets may be positive or negative, with absolute ', &
!!$             & ' values no larger than',int(0.5*np1),int(0.5*np2),int(0.5*np3)
!!$     endif
!!$     read(*,*) m1off,m2off,m3off
!!$     !  Now get coordinates for tidal volume.
!!$     if (myid==0) print*,'Enter size (m1t,m2t,m3t) of the final subvolume, ', &
!!$          &      'in units of top grid spacing'
!!$     read(*,*) m1t,m2t,m3t
!!$     if (m1t.gt.m1s.or.m2t.gt.m2s.or.m3t.gt.m3s) then
!!$        if (myid==0) print*,'Error! Final subvolume cannot be larger than ', &
!!$             &        'level-1 subgrid'
!!$        call mpi_finalize(ierr)
!!$        stop
!!$     end if
!!$     if (myid==0) then
!!$        print*,'Enter offset of final subvolume (m1offt,m2off2,m3offt).'
!!$        print*,'  Offsets are relative to level-0 grid corner.'
!!$        print*,'  Final subvolume must lie within level-1 subgrid'
!!$     endif
!!$     read(*,*) m1offt,m2offt,m3offt
!!$     if (m1offt.lt.m1off.or.m1offt+m1t.gt.m1off+m1s.or. &
!!$          &        m2offt.lt.m2off.or.m2offt+m2t.gt.m2off+m2s.or. &
!!$          &        m3offt.lt.m3off.or.m3offt+m3t.gt.m3off+m3s) then
!!$        if (myid==0) print*,'Error! Final subvolume isn''t contained within ', &
!!$             &             'level-1 subgrid'
!!$        call mpi_finalize(ierr)
!!$        stop
!!$     end if
!!$     !  Coordinates of the subgrid corner.
!!$     x1o=m1off*dx
!!$     x2o=m2off*dx
!!$     x3o=m3off*dx
!!$     if (myid==0) then
!!$        print*,'Grafic1 will output level-1 subgrid as follows:'
!!$        print*,'  xmin, xmax = ',x1o,x1o+m1s*dx
!!$        print*,'  ymin, ymax = ',x2o,x2o+m2s*dx
!!$        print*,'  zmin, zmax = ',x3o,x3o+m3s*dx
!!$        print*,'Grafic1 will compute tides assuming final subvolume:'
!!$        print*,'  xmin, xmax = ',m1offt*dx,(m1offt+m1t)*dx
!!$        print*,'  ymin, ymax = ',m2offt*dx,(m2offt+m2t)*dx
!!$        print*,'  zmin, zmax = ',m3offt*dx,(m3offt+m3t)*dx
!!$     endif
!!$     !  Open output file and write header.
!!$     open(10,file='grafic2.top',form='unformatted',status='unknown')
!!$     rewind 10
!!$     write(10)  2*m1s,2*m2s,2*m3s,dx,x1o,x2o,x3o,m1t,m2t,m3t, &
!!$          &      m1offt-m1off,m2offt-m2off,m3offt-m3off,hanning,astart, &
!!$          &      omegam,omegav,h0
!!$     if (myid==0) print*,'Output file is grafic2.top; use as input to subsequent', &
!!$          &           ' run of grafic2'
!!$  else
  hanning=.false.
  m1s=np1 !Unused here...
  m2s=np2 !Unused here...
  m3s=np3 !Unused here...
  x1o=0.0
  x2o=0.0
  x3o=0.0
  if (myid==0) then
     print*,'Setting output grid to ',m1s,m2s,m3s
     print*,'Enter <RETURN> to skip output grid size'
     read(infile_id,*)
     print*,'Enter <RETURN> to skip output grid offset'
     read(infile_id,*)
     print*,'Enter <RETURN> to skip final grid size'
     read(infile_id,*)
     print*,'Enter <RETURN> to skip final grid offset'
     read(infile_id,*)
     print*,'Will produce output files ic_deltab, ic_velb[xyz],', &
          &           ' ic_velc[xyz]'
  endif
!!$end if
  call mpi_barrier(mpi_comm_world,ierr)
  !  Set parameters for subgrid noise.
  if (myid==0) then
     print*
     print*,'Subgrid white noise:'
     print*,'  Choose irand (1 or 2) from the following list:'
     !  print*,'    irand=0 to generate new noise and don''t save it'
     print*,'    irand=1 to generate new noise and save to file'
     print*,'    irand=2 to read noise from existing file'
     print*,'Enter irand'
     read(infile_id,*) irand
     print*, irand
  endif
  call mpi_barrier(mpi_comm_world,ierr)
  call mpi_bcast(irand,1,mpi_integer,0,mpi_comm_world,ierr)
  if (irand.lt.0.or.irand.gt.2) then
     if (myid==0) print*,'Illegal value of irand'
     call mpi_finalize(ierr)
     stop
  end if

  if (myid==0) then
     print*,'  Enter random number seed (9-digit integer, ignored ', &
          &    'if irand=2)'
     read(infile_id,*) iseed
     write(*,'(i12)') iseed
  endif
  call mpi_barrier(mpi_comm_world,ierr)
#ifdef HAVE_LIBGSL
  call mpi_bcast(iseed,1,mpi_integer8,0,mpi_comm_world,ierr)
#else
  call mpi_bcast(iseed,1,mpi_integer,0,mpi_comm_world,ierr)
#endif
  filename=''
  if (myid==0) then
     print*,'  Enter filename of white noise file (or <RETURN> ', &
          &    'if irand=0)'
     read(infile_id,'(a)') filename
     print*,filename
  endif
  call mpi_barrier(mpi_comm_world,ierr)
  ! filename='white.dat'
  ! filename is needed by other cpus (to read or write)
  call mpi_bcast(filename,128,mpi_character,0,mpi_comm_world,ierr)
  ! print*,'in mpgrafic, filename is ','***'//trim(filename)//'***'

  ! Ask if padding of small k modes is required
  if (myid==0) then
     print*,' Enter 1 if padding of large scales is required, 0 otherwise'
     read(infile_id,*) ipad
     print*, ipad
  endif
  call mpi_barrier(mpi_comm_world,ierr)
  call mpi_bcast(ipad,1,mpi_integer,0,mpi_comm_world,ierr)
  small_file_name=''
  if (myid==0) then
     print*,' Enter padding file name (white noise format, ignored if ipad=0)'
     read(infile_id,'(a)') small_file_name
     print*, small_file_name

     ! close file if stdin not used
     if(infile_id == input_param_file_id)then
        close(infile_id)
     endif
  endif
  call mpi_barrier(mpi_comm_world,ierr)
  call mpi_bcast(small_file_name,128,mpi_character,0,mpi_comm_world,ierr)

  ! Compute small k modes from small file and store them, if needed
  small_kfile_name='ksmall'
  if (ipad==1) then
     if (myid==0) then
        print*,' Will compute the large scales from file ', trim(small_file_name)
        print*,' Beware that the large scales are assumed to be prewhitened, '
        print*,' and that the constraints are assumed to be imposed with the same '
        print*,' power spectrum: cosmologies of small and large k modes need to be '
        print*,' consistent...'
     endif
!!$     call grafic_read_header(small_file_name,shtaille,shcosmo)
!!$     nxs=shtaille%nx
!!$     nys=shtaille%ny
!!$     nzs=shtaille%nz
     call grafic_read_header_white(small_file_name,nxs,nys,nzs,iseeds)
     call rfftw3d_f77_mpi_create_plan_c_wrap(plan,mpi_comm_world,nxs,nys,nzs, &
          & fftw_real_to_complex,fftw_estimate)
     call rfftwnd_f77_mpi_local_sizes(plan,local_nzs,local_z_starts, &
          & local_nys, local_y_starts, total_local_sizes)
     allocate(f(total_local_sizes))
     call grafic_read(f,local_nzs,local_z_starts,nys,nxs,small_file_name,white_in=.true.)
     ! Make sure avg is 0 and rms is 1
#ifndef NO_NORM_WHITE
     call mpnorm(local_nzs,nzs,nys,nxs,total_local_sizes,f)
#endif
     ! Normalise a la Bertschinger
     f = f/sqrt(real(nxs*nys,dp)*nzs)
     call fft_mpi(plan,f,total_local_sizes)
     ! Scale small grid power to large grid
     ! f = f*real(np1*np2,dp)*np3/real(nxs*nys*nzs,dp)
     call rfftwnd_f77_mpi_destroy_plan(plan)
     shtaille%nx=nxs
     shtaille%ny=nys
     shtaille%nz=nzs
     if (myid==0) call grafic_write_header(small_kfile_name,shtaille, &
          & shcosmo)
     call mpi_barrier(mpi_comm_world,ierr)
     call grafic_write(f,local_nzs,local_z_starts,nys,nxs,small_kfile_name, &
          & padding_in=.true.)
     deallocate(f)
  endif

  ! Compute local buffer size from total grid size, and prepare fftw
  ! plans. Beware that domain decomposition is done along nx...
  ! (Slowest varying dimension in the array)

  call rfftw3d_f77_mpi_create_plan_c_wrap(plan,mpi_comm_world,nx,ny,nz, &
       fftw_real_to_complex, fftw_estimate)
  call rfftw3d_f77_mpi_create_plan_c_wrap(iplan,mpi_comm_world,nx,ny,nz, &
       fftw_complex_to_real, fftw_estimate)
  call rfftwnd_f77_mpi_local_sizes(plan,local_nz,local_z_start,local_ny, &
       local_y_start,total_local_size)

  if (total_local_size <= 0) then
        if (myid==0) then
          print*,'Beware: size of local buffers does not fit in 4 bits !'
          print*,'Use with a bigger number of processes ...'
          print*,'Aborting'
        endif
     call mpi_finalize(ierr)
     stop

  endif
!
  !  Outer loop over components to be refined.
  !
  do icomp=0,12
     !  0: baryon density.
     !  1,2: inner,outer baryon x-velocity.
     !  3,4: inner,outer baryon y-velocity.
     !  5,6: inner,outer baryon z-velocity.
     !  7,8: inner,outer CDM x-velocity.
     !  9,10: inner,outer CDM y-velocity.
     !  11,12: inner,outer CDM z-velocity.
     !
     !  If not generating grafic2.dat for further refinement, and
     !    if icomp=odd, then skip.
     if (mod(icomp,2).eq.1) cycle
     !
     !  Optional half-grid offset to velocity fields.
     if (icomp.gt.0.and.icomp.le.6) then
        xoff=0.5*dx*offvelb
     else if (icomp.gt.6) then
        xoff=0.5*dx*offvelc
     else
        xoff=0.0
     end if
     !  Don't need to recompute random numbers.
     if (icomp.gt.0.and.irand.eq.1) irand=2
     !
     !  Generate random fields.  idim=0,1,2,3 for density, displacement.
     itide=0
     if (mod(icomp,2).eq.0) then
        idim=icomp/2
        !  Outer case.
        ! if (.not.hanning.and.idim.gt.0) itide=1
     else
        !  Inner case.
        idim=(icomp+1)/2
        ! if (.not.hanning.and.idim.gt.0) itide=-1
     end if
     allocate(f(total_local_size),stat=status)
     if (status /= 0) then
        print*,'Could not allocate array, aborting'
        call mpi_finalize(ierr)
        stop
     endif
     ! First Feed the headers...
     headt%nx=np1
     headt%ny=np2
     headt%nz=np3
     headt%dx=dx
     headt%lx=x1o+xoff
     headt%ly=x2o+xoff
     headt%lz=x3o+xoff
     headc%astart=astart
     headc%omegam=omegam
     headc%omegav=omegav
     headc%h0=h0

     if (idim.le.3) then
        call mpic4(idim,irand,iseed,itide,m1t,m2t,m3t,m1offt,m2offt, &
             &     m3offt,hanning,filename,astart,pbar,dx,xoff,f,fm, &
             &     plan,iplan,local_nz,local_z_start,total_local_size, &
             &     headt,headc,small_kfile_name,ipad, &
             &     np1,np2,np3)
     else
        idim=idim-3
        call mpic4(idim,irand,iseed,itide,m1t,m2t,m3t,m1offt,m2offt, &
             &     m3offt,hanning,filename,astart,pcdm,dx,xoff,f,fm, &
             &     plan,iplan,local_nz,local_z_start,total_local_size, &
             &     headt,headc,small_kfile_name,ipad, &
             &     np1,np2,np3)
     end if

     !
     !  Prepare data for output.
     !
     if (.true.) then
        ! For a version of RAMSES much older than 2013, you may have
        ! to comment out the following line; however, using such an
        ! out-of-date version of RAMSES would be unwise.
        if (idim > 0) f = f*vfact
        ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        !  Output files.
        if (icomp.eq.0) then
           outputfile='ic_deltab'
        else if (icomp.eq.2) then
           outputfile='ic_velbx'
        else if (icomp.eq.4) then
           outputfile='ic_velby'
        else if (icomp.eq.6) then
           outputfile='ic_velbz'
        else if (icomp.eq.8) then
           outputfile='ic_velcx'
        else if (icomp.eq.10) then
           outputfile='ic_velcy'
        else if (icomp.eq.12) then
           outputfile='ic_velcz'
        end if
        if (myid==0) then
           headt%nx=np1
           headt%ny=np2
           headt%nz=np3
           headt%dx=dx
           headt%lx=x1o+xoff
           headt%ly=x2o+xoff
           headt%lz=x3o+xoff
           headc%astart=astart
           headc%omegam=omegam
           headc%omegav=omegav
           headc%h0=h0
           call grafic_write_header(outputfile,headt,headc)
        endif
        call mpi_barrier(mpi_comm_world,ierr)
        call grafic_write(f,local_nz,local_z_start,ny,nx,outputfile)
     endif ! subgrid is not implemented...

!!$  else
!!$     !  hanning=F, extract next-level subgrid and append to grafic2.dat.
!!$     !  First surround subvolume with 1/2-size buffer and wrap periodically.
!!$     sigma=0.0
!!$     do m3=1,2*m3s
!!$        i3=m3+m3off
!!$        !  Periodic boundary conditions on top grid.
!!$        if (i3.lt.1) i3=i3+np3
!!$        if (i3.gt.np3) i3=i3-np3
!!$        l3=i3
!!$        if (m3.gt.1.5*m3s) l3=l3-2*m3s
!!$        if (l3.lt.1) l3=l3+np3
!!$        do m2=1,2*m2s
!!$           i2=m2+m2off
!!$           if (i2.lt.1) i2=i2+np2
!!$           if (i2.gt.np2) i2=i2-np2
!!$           l2=i2
!!$           if (m2.gt.1.5*m2s) l2=l2-2*m2s
!!$           if (l2.lt.1) l2=l2+np2
!!$           do m1=1,2*m1s
!!$              i1=m1+m1off
!!$              if (i1.lt.1) i1=i1+np1
!!$              if (i1.gt.np1) i1=i1-np1
!!$              l1=i1
!!$              if (m1.gt.1.5*m1s) l1=l1-2*m1s
!!$              if (l1.lt.1) l1=l1+np1
!!$              slice(m1,m2)=f(l1,l2,l3)
!!$              sigma=sigma+f(l1,l2,l3)**2
!!$           end do
!!$        end do
!!$        write(10) ((slice(m1,m2),m1=1,2*m1s),m2=1,2*m2s)
!!$     end do
!!$     sigma=sqrt(sigma/(8*m1s*m2s*m3s))
!!$     if (myid==0) print*,'After extraction, component ',icomp, &
!!$          &      ' has subvolume RMS=',real(sigma)
!!$  end if
     !  End loop over icomp.
     deallocate(f)
  enddo
  !
!!$if (.not.hanning) close(10)
  call mpi_finalize(ierr)
  stop
end program grafic1

  !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
function dsigma(ak)
  !  This function calculates the variance of density with a Hanning
  !  filter at the grid Nyquist frequency.
  !
  implicit none
  double precision dsigma,ak
  real asig,dx,p
  common /dsig/ asig,dx
  external p
  !
  if (ak.le.0.0d0.or.ak.gt.3.1415926535898d0/dx) then
     dsigma=0.0d0
     return
  end if
  !  Hanning filter.
  dsigma=ak*ak*p(real(ak),asig)*cos(0.5*ak*dx)
  !
  return
end function dsigma

  !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
function dsigmadispl(ak)
  !  This function calculates the variance of displacement with a Hanning
  !  filter at the grid Nyquist frequency.
  !
  implicit none
  double precision dsigmadispl,ak
  real asig,dx,p
  common /dsig/ asig,dx
  external p
  !
  if (ak.le.0.0d0.or.ak.gt.3.1415926535898d0/dx) then
     dsigmadispl=0.0d0
     return
  end if
  !  Hanning filter.
  dsigmadispl=ak*ak*p(real(ak),asig)/ak/ak/3.*cos(0.5*ak*dx)
  !
  return
end function dsigmadispl

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!   Copyright (C) 2008-2019 by Simon Prunet, Christophe Pichon et al     !
!   prunet iap.fr                                                        !
!                                                                        !
!   This program is free software; you can redistribute it and/or modify !
!   it under the terms of the GNU General Public License as published by !
!   the Free Software Foundation; either version 2 of the License, or    !
!   (at your option) any later version.                                  !
!                                                                        !
!   This program is distributed in the hope that it will be useful,      !
!   but WITHOUT ANY WARRANTY; without even the implied warranty of       !
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        !
!   GNU General Public License for more details.                         !
!                                                                        !
!   You should have received a copy of the GNU General Public License    !
!   along with this program; if not, write to the                        !
!   Free Software Foundation, Inc.,                                      !
!     59 Temple Place - Suite 330, Boston, MA  02111-1307, USA           !
!   or see https://www.gnu.org/licenses/licenses.html#GPL .              !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module paste

  use grafic_types
  use grafic_io
  !use derivative, only: init_kgrid,kx,ky,kz
  implicit none

contains

  subroutine grid_paste(local_z_start,local_nz,head_taille,head_cosmo,buffer,small_file_name)

    !Arguments
    integer, intent(in) :: local_z_start,local_nz
    type(cosmo), intent(in) :: head_cosmo
    type(taille), intent(in) :: head_taille
#ifdef DOUB
    real(dp), dimension(:), intent(inout) :: buffer
#else
    real(sp), dimension(:), intent(inout) :: buffer
#endif
    character(len=128), intent(in) :: small_file_name

    ! Local variables
    type(cosmo) :: small_head_cosmo
    type(taille) :: small_head_taille
    integer :: nx, nxs, ny, nys, nz, nzs, n2x, n2xs
    real(dp) :: dx, dxs
    integer :: ierr !myid
    logical :: debut=.false., fin=.false.
    integer :: local_nzs, local_z_starts, local_z_start_end
    integer :: i,j,k,kk
    integer(i8b) :: index_big, index_small

#ifdef DOUB
    real(dp), dimension(:), allocatable :: sbuffer
#else
    real(sp), dimension(:), allocatable :: sbuffer
#endif

    ! Read small file header, and verify its compliance with big cube header
    call grafic_read_header(small_file_name,small_head_taille,small_head_cosmo)
    nx=head_taille%nx
    ny=head_taille%ny
    nz=head_taille%nz
    dx=head_taille%dx
    nxs=small_head_taille%nx
    nys=small_head_taille%ny
    nzs=small_head_taille%nz
    dxs=small_head_taille%dx

    n2x=2*(nx/2+1)
    n2xs=2*(nxs/2+1)

    call mpi_barrier(MPI_COMM_WORLD,ierr)

!!$    call mpi_comm_rank(MPI_COMM_WORLD,myid,ierr)
!!$    if (nxs > nx .or. nys > ny .or. nzs > nz) then
!!$       if (myid==0) print*,'Wrong box sizes, aborting'
!!$       call mpi_finalize(ierr)
!!$       stop
!!$    endif
!!$
!!$    if (nx*dx /= nxs*dxs) then
!!$       if (myid==0) print*,'Incompatible physical box sizes, aborting'
!!$       call mpi_finalize(ierr)
!!$       stop
!!$    endif
!!$
!!$    if (head_cosmo%astart/=small_head_cosmo%astart .or. &
!!$         & head_cosmo%omegam/=small_head_cosmo%omegam .or. &
!!$         & head_cosmo%omegav/=small_head_cosmo%omegav .or. &
!!$         & head_cosmo%h0/=small_head_cosmo%h0) then
!!$       if (myid==0) print*,'Incompatible cosmological parameters, aborting'
!!$       call mpi_finalize(ierr)
!!$       stop
!!$    endif

    ! verify that modes need to be pasted
    ! debut is .true. if positive kz modes need padding
    ! fin is .true. if negative kz modes need padding
    ! Beware that all values of the pair (debut,fin) can happen ...
    ! The pasting policy is to get rid of all Nyquist planes in the small
    ! box, and retain the corresponding (non-Nyquist) frequencies (positive
    ! and negative) of the large box.

    ! First element is a positive (small) kx frequency (Nyquist excluded)
    if (local_z_start <= nzs/2-1) debut=.true.
    ! Last element is a negative (small) kx frequency
    if (local_z_start+local_nz-1 >= nz-nzs/2+1) fin=.true.

    if (debut) then
          local_nzs = min(local_z_start+local_nz,nzs/2)-local_z_start
          local_z_starts = local_z_start
       allocate(sbuffer(local_nzs*nys*n2xs))
       ! Read small k grid. This avoids complicated communication ...
       call grafic_read(sbuffer,local_nzs,local_z_starts,nys,nxs, &
            & small_file_name,padding_in=.true.)
       ! Fill "debut": positive kx frequency modes
       do k=1,local_nzs
          ! Fill positive ky frequency modes, including ky=0, skipping nyq_y
          do j=1,nys/2
             do i=1,n2xs-2 ! Skip nyq_z
                index_big = int((k-1)*ny+j-1,8)*n2x+i
                index_small = ((k-1)*nys+j-1)*n2xs+i
                buffer(index_big)=sbuffer(index_small)
             enddo
          enddo
          ! Now fill negative ky frequency modes
          do j=nys/2+2,nys
             do i=1,n2xs-2
                index_big = int((k-1)*ny+j+ny-nys-1,8)*n2x+i
                index_small = ((k-1)*nys+j-1)*n2xs+i
                buffer(index_big)=sbuffer(index_small)
             enddo
          enddo
       enddo
       deallocate(sbuffer)
    endif

    if (fin) then
       local_z_start_end = max(local_z_start,nz-nzs/2+1)
       local_z_starts = local_z_start_end-nz+nzs ! Small cube index
       local_nzs = local_nz - (local_z_start_end - local_z_start)

       allocate(sbuffer(local_nzs*nys*n2xs))
       call grafic_read(sbuffer,local_nzs,local_z_starts,nys,nxs, &
            & small_file_name,padding_in=.true.)
       ! Fill "fin": negative kx frequency modes
       do k=1,local_nzs
          kk = k+local_z_start_end-local_z_start
          ! Fill positive ky frequency modes, including ky=0, skipping nyq_y
          do j=1,nys/2
             do i=1,n2xs-2 ! Skip nyq_z
                index_big = int((kk-1)*ny+j-1,8)*n2x+i
                index_small = ((k-1)*nys+j-1)*n2xs+i
                buffer(index_big)=sbuffer(index_small)
             enddo
          enddo
          ! Fill negative ky frequency modes
          do j=nys/2+2,nys
             do i=1,n2xs-2
                index_big = int((kk-1)*ny+j+ny-nys-1,8)*n2x+i
                index_small = ((k-1)*nys+j-1)*n2xs+i
                buffer(index_big)=sbuffer(index_small)
             enddo
          enddo
       enddo
       deallocate(sbuffer)
    endif


  end subroutine grid_paste

end module paste

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!   Copyright (C) 2008-2019 by Simon Prunet, Christophe Pichon et al     !
!   prunet iap.fr                                                        !
!                                                                        !
!   This program is free software; you can redistribute it and/or modify !
!   it under the terms of the GNU General Public License as published by !
!   the Free Software Foundation; either version 2 of the License, or    !
!   (at your option) any later version.                                  !
!                                                                        !
!   This program is distributed in the hope that it will be useful,      !
!   but WITHOUT ANY WARRANTY; without even the implied warranty of       !
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        !
!   GNU General Public License for more details.                         !
!                                                                        !
!   You should have received a copy of the GNU General Public License    !
!   along with this program; if not, write to the                        !
!   Free Software Foundation, Inc.,                                      !
!     59 Temple Place - Suite 330, Boston, MA  02111-1307, USA           !
!   or see https://www.gnu.org/licenses/licenses.html#GPL .              !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
#include "../config.h"

subroutine mpic4(idim,irand,iseed,itide,m1s,m2s,m3s,m1off, &
     &    m2off,m3off,hanning,filename,astart,pk,dx,xoff,f,fm, &
     &    plan,iplan,local_nz,local_z_start,total_local_size, &
     &    headt,headc,small_kfile_name,ipad, &
     &    np1,np2,np3)
  !  Generate an unconstrained sample of (rho,psi1,psi2,psi3,phi) for
  !  idim=0,1,2,3,4.
  !  Input: idim, irand, iseed, itide, m?s, m?off, hanning, filename,
  !         astart, pk, dx, xoff
  !  irand=0: use randg to generate white noise, don't save.
  !  irand=1: use randg to generate white noise, then save in real space
  !    in filename.
  !  irand=2: read filename to get random numbers.
  !  iseed: 64-bit signed integer random number seed if GSL is available;
  !    otherwise, 32-bit signed integer random number seed.
  !    Beware that the pseudo-random values will differ between these
  !    two cases!
  !  itide=0 to use full subvolume for computing f.
  !  itide=1 to set xi=0 inside subvolume so as to get outer field.
  !  itide=-1 to set xi=0 outside subvolume so as to get inner field.
  !  m?s = size of next-level subvolume to split if itide.ne.0.
  !  m?off = offset of next-level subvolume to split if itide.ne.0
  !  hanning=T to apply hanning filter to f.
  !  hanning=F to not apply hanning filter to f.
  !  filename = file containing random numbers in real space.
  !  astart = expansion factor
  !  pk(ak,astart) = power spectrum function for wavenumber ak
  !  dx = grid spacing.
  !  xoff = offset to evaluate fields (e.g. use to shift baryon or cdm fields).
  !  Output: f=fc (sampled field in real space), fm (maximum absolute value of f).
  !  N.B. f and fc must point to the same place in memory - they are listed
  !  separately in the subroutine call because f77 will not allow equivalencing
  !  pointers.  The calling routine must pass the same pointer for each.
  use grafic_types
  use grafic_io
  use transform
  use normalize
  use iso_C_binding
#ifdef HAVE_LIBGSL
  use wrap_gsl_rng_mod
#endif
  use random
  use paste

  implicit none
#include "grafic1.inc"
  integer :: np1, np2, np3
  integer :: n12,n22,n32,n23,n2p1,npow
  !parameter (n12=np1/2,n22=np2/2,n32=np3/2,n23=np2*np3)
  !parameter (n2p1=2*(np1/2+1))
  parameter (npow=30720)
  integer idim,irand,itide,m1s,m2s,m3s,m1off,m2off,m3off
#ifdef HAVE_LIBGSL
  integer (c_int64_t) iseed
#else
  integer iseed
#endif
  logical hanning
  character(len=128) :: filename, small_kfile_name
  integer :: ipad
  type(taille) :: headt
  type(cosmo) :: headc
  real astart,pk,dx,xoff,fm
  type(c_ptr) :: plan, iplan
  integer :: local_nz, local_z_start
  integer :: total_local_size
#ifdef DOUB
  real(dp), dimension(total_local_size) :: f
#else
  real(sp), dimension(total_local_size) :: f
#endif
  integer :: myid, nproc, ierr, i_proc
#ifdef HAVE_LIBGSL
  integer(c_int64_t) :: seeds(MaxRandNumStreams,1)
  integer(c_int64_t) :: seed_myid ! avoid repeatedly re-calculating address
#else
  integer :: seeds(MaxRandNumStreams,IRandNumSize)
#endif

  integer(i8b) :: index
  complex(dpc) :: z, ctemp

  !real(dp) :: debug

  real lfm
  real(dp) :: twopi,avg,lavg,sigma,lsigma,chisq,lchisq
  parameter (twopi=6.283185307179586d0)
  integer j,i1,i2,i3,k1,k2,k3,k23,jp,modes
  integer(i8b) :: ndof
  real dk1,dk2,dk3,d3k,akmax,akmaxf,ak,ak23,akk,fact
  real(dp) :: xr
  real ak1,ak2,ak3,ak33,anu,dq,tf,tsav(0:npow),theta
  !logical inflag, white_in
  external pk

  n12=np1/2
  n22=np2/2
  n32=np3/2
  n23=np2*np3
  n2p1=2*(np1/2+1)

  call mpi_comm_rank(mpi_comm_world,myid,ierr)
  call mpi_comm_size(mpi_comm_world,nproc,ierr)

  if (idim.lt.0.or.idim.gt.4) then
     if (myid==0) print*,'Error in ic4! Need idim=0,1,2,3,4'
     call mpi_finalize(ierr)
     stop
  end if
  if (irand.lt.0.or.irand.gt.2) then
     if (myid==0) print*,'Error in ic4! Need irand=0,1,2'
     call mpi_finalize(ierr)
     stop
  end if
  if (itide.lt.-1.or.itide.gt.1) then
     if (myid==0) print*,'Error in ic4! Need itide=-1,0,1'
     call mpi_finalize(ierr)
     stop
  end if
  dk1=twopi/(np1*dx)
  dk2=twopi/(np2*dx)
  dk3=twopi/(np3*dx)
  d3k=dk1*dk2*dk3
  akmax=twopi/dx
  !  Precompute transfer function table for interpolation.
  !  N.B. must go to at least sqrt(3)*akmax/2 unless use Hanning filter,
  !  in which case go to akmax/2.
  if (hanning) then
     akmaxf=akmax/2.0
  else
     akmaxf=akmax
  end if
  do j=0,npow
     ak=j*akmaxf/npow
     tsav(j)=sqrt(pk(ak,astart)*d3k)
     if (hanning) tsav(j)=tsav(j)*cos(0.5*ak*dx)
     if (idim.gt.0.and.j.gt.0) then
        tsav(j)=tsav(j)/(ak*ak)
     end if
  end do
  !  Get white noise sample.
  if (irand.lt.2) then
     if (myid==0) print*,'Warning: Generating new random numbers in mpic4!'

#ifdef HAVE_LIBGSL
     ! create GSL rng object for generating seeds
     if(nproc > MaxRandNumStreams) &
          write(*,'(a,i8,a,i8)')'Warning: nproc = ',nproc, &
          '> MaxRandNumStreams = ',MaxRandNumStreams
     if(myid.eq.0)call get_gsl_rng_seeds &
             (iseed, MaxRandNumStreams, seeds(:,1))
#else
     call rans(nproc,iseed,seeds) ! Generate seeds for parallel random number generator
#endif
     call mpi_barrier(mpi_comm_world,ierr)
     if(myid.eq.0)write(*,'(a,i12,i12)')' myid,seeds: ',myid,seeds(1:nproc,1)
#ifdef HAVE_LIBGSL
     if(myid.eq.0)then
        ! Send the seeds to each other thread (in GSL case really only
        ! need to send one seed, but seeds is declared for the general case):
        do i_proc=1,nproc-1
           ! TODO: replace by broadcast or scatter?
           call mpi_send(seeds,MaxRandNumStreams,mpi_integer8,i_proc, &
                0, &
                mpi_comm_world, ierr) ! send the seeds
        enddo
     else
        call mpi_recv(seeds,MaxRandNumStreams,mpi_integer8,0, &
             0, &
             mpi_comm_world, MPI_STATUS_IGNORE, ierr)
     endif
#endif
     ! Warning about nproc > MaxRandNumStreams given above.
#ifdef HAVE_LIBGSL
     seed_myid = seeds(mod(myid,MaxRandNumStreams)+1, 1)
#endif
     do i3=1,local_nz
        do i2=1,np2
           do i1=1,np1
              index = int((i3-1)*np2+i2-1,8)*n2p1+i1
#ifdef HAVE_LIBGSL
              call gauss_gsl(seed_myid,xr,0)
#else
              call gaussdev(seeds(myid+1,:),xr)
#endif
#ifdef DOUB
              f(index)=xr
#else
              f(index)=real(xr,kind=sp)
#endif
           end do
        end do
     end do
#ifdef HAVE_LIBGSL
     call gauss_gsl(seed_myid,xr,1) ! free memory on this thread
#endif


     !  Output white noise field.
     if (irand.eq.1 .and. ipad.eq.0) then
        if (myid==0) then
           call grafic_write_header_white(filename,np1,np2,np3,iseed)
        endif
        call mpi_barrier(mpi_comm_world,ierr)
        call grafic_write(f,local_nz,local_z_start,np2,np1,filename,white_in=.true.)
     end if
  else
     !  irand=2.
     if (myid==0) then
        print*,'Reading random numbers used in ic4 from ',trim(filename)
        call grafic_read_header_white(filename,i1,i2,i3,iseed)
     endif
     call mpi_barrier(mpi_comm_world,ierr)
     call mpi_bcast(i1,1,mpi_integer,0,mpi_comm_world,ierr)
     call mpi_bcast(i2,1,mpi_integer,0,mpi_comm_world,ierr)
     call mpi_bcast(i3,1,mpi_integer,0,mpi_comm_world,ierr)
#ifdef HAVE_LIBGSL
     call mpi_bcast(iseed,1,mpi_integer8,0,mpi_comm_world,ierr)
#else
     call mpi_bcast(iseed,1,mpi_integer,0,mpi_comm_world,ierr)
#endif
     if (i1.ne.np1.or.i2.ne.np2.or.i3.ne.np3) then
        if (myid==0) then
           print*,'Error in ic4! file has np1,np2,np3=',i1,i2,i3
           print*,' Expected ',np1,np2,np3
        endif
        call mpi_finalize(ierr)
        stop
     end if
     if (myid==0) write(*,'(a,i12)')'   Random numbers generated with iseed=',iseed
     call mpi_barrier(mpi_comm_world,ierr)
     call grafic_read(f,local_nz,local_z_start,np2,np1,filename,white_in=.true.)

  end if
  ! Make sure input (big) white noise box has stdev=1
  ! Putting this out of if construct makes sure that ic_deltab is the
  ! same wether irand=2 or irand=1 (when recycling the same white
  ! noise box of course). Small difference remains if compiled with
  ! DOUB, because white noise is stored in single precision
  ! Can be bypassed by defining NO_NORM_WHITE at compile time.
#ifndef NO_NORM_WHITE
  if (myid==0) then
     print*,'Normalizing rms, subtracting average'
  endif
  call mpnorm(local_nz,np3,np2,np1,total_local_size,f)
#endif
  !  Compute mean.
  lavg=0.0
  do i3=1,local_nz
     do i2=1,np2
        do i1=1,np1
           index = int((i3-1)*np2+i2-1,8)*n2p1+i1
#ifdef DOUB
           lavg=lavg+f(index)
#else
           lavg=lavg+real(f(index),kind=dp)
#endif
        end do
     end do
  end do
  ! Mean is needed on every cpu
  !print*,'lavg = ',lavg
  call mpi_allreduce(lavg,avg,1,mpi_double_precision,mpi_sum,mpi_comm_world,ierr)
  avg=avg/(real(np1*np2,dp)*np3)
  fact=sqrt(1.0*np1*np2*np3)

  !  Enforce zero mean for simulations with periodic boundary conditions.
  !  Compute chisq for this sample, too.
  lchisq=0.0
  do i3=1,local_nz
     do i2=1,np2
        do i1=1,np1
           !  Subtract mean.
           index=int((i3-1)*np2+i2-1,8)*n2p1+i1
#ifdef DOUB
           f(index)=f(index)-avg
#else
           f(index)=f(index)-real(avg,kind=sp)
#endif
           lchisq=lchisq+f(index)**2
           !  Standard deviation is fact, but divide by np1*np2*np3=fact**2 to
           !  normalize f for FFT
#ifdef DOUB
           f(index)=f(index)/fact
#else
           f(index)=f(index)/real(fact,kind=sp)
#endif
        end do
     end do
  end do

  call mpi_reduce(lchisq,chisq,1,mpi_double_precision,mpi_sum,0,mpi_comm_world,ierr)

  ndof=int(np1*np2,8)*np3-1
  anu=(chisq-ndof)/sqrt(float(ndof))
  if (myid==0) &
       write(*,'(a,f15.5,i15,es15.5)') 'ic4 white noise: chisq, dof, nu=', &
       & real(chisq),ndof,anu
  !  Transform noise to k-space.
  call fft_mpi(plan,f,total_local_size)


  ! Paste if needed large scales, before applying transfer function
  ! This means that the large scales have been prewhitened ...
  if (ipad .eq. 1) then
     call grid_paste(local_z_start,local_nz,headt,headc,f,small_kfile_name)
     if (irand .eq. 1) then ! Output padded white noise file
        if (myid==0) then
           call grafic_write_header_white(filename,np1,np2,np3,iseed)
        endif
        call mpi_barrier(mpi_comm_world,ierr)
        call fft_mpi(iplan,f,total_local_size)
        f = f/fact ! Renormalize to compensate backward FFT
        call grafic_write(f,local_nz,local_z_start,np2,np1,filename,white_in=.true.)
        call fft_mpi(plan,f,total_local_size)
        f = f/fact ! Renormalize to compensate forward FFT
     endif
  endif

  lchisq=0.0
  lsigma=0.0
  !  Generate unconstrained sample in Fourier transform space.
  do k3=1,local_nz
     ak3=(k3+local_z_start-1)*dk3
     if (k3+local_z_start.gt.n32) ak3=ak3-akmax
     ak33=ak3*ak3
     do k2=1,np2
        ak2=(k2-1)*dk2
        if (k2.gt.n22) ak2=ak2-akmax
        ak23=ak2*ak2+ak33
        k23=k2-1+(k3-1)*np2
        do k1=1,n12 ! Complex
           !  Do k1=n12+1 separately below.
           ak1=(k1-1)*dk1
           akk=ak1*ak1+ak23
           ak=sqrt(akk)
           !  Evaluate transfer function.
           dq=npow*ak/akmaxf
           if (dq.ge.npow) then
              tf=0.0
           else
              jp=int(dq)
              dq=dq-jp
              tf=(1.0-dq)*tsav(jp)+dq*tsav(jp+1)
           end if
           !  Shift using offsets, with care at the Brillouin zone boundaries.
           theta=ak1*xoff
           if (k2.ne.n22+1) theta=theta+ak2*xoff
           if (k3+local_z_start.ne.n32+1) theta=theta+ak3*xoff
           z=cmplx(cos(theta),sin(theta),kind=dpc)

           !  These factors correctly average shifts at the Nyquist planes.
           if (k2.eq.n22+1) z=z*cos(ak2*xoff)
           if (k3+local_z_start.eq.n32+1) z=z*cos(ak3*xoff)
           !  Convolve white noise with transfer function.
           index = int((k3-1)*np2+k2-1,8)*n2p1+2*k1-1 !Real index
#ifdef DOUB
           ctemp = cmplx(f(index),f(index+1),kind=dpc)
#else
           ctemp = cmplx(real(f(index),kind=dp),real(f(index+1),kind=dp))
#endif
           ctemp = ctemp*z*tf

           if (idim.eq.1) then
              ctemp=cmplx(0.0,1.0)*ak1*ctemp
           else if (idim.eq.2) then
              ctemp=cmplx(0.0,1.0)*ak2*ctemp
              if (k2.eq.n22+1) ctemp=0.0
           else if (idim.eq.3) then
              ctemp=cmplx(0.0,1.0)*ak3*ctemp
              if (k3+local_z_start.eq.n32+1) ctemp=0.0
           end if
           !  Double the contribution to account for modes with k1 > n12+1 (k1 < 0).
           modes=2
           if (k1.eq.1) modes=1
           lsigma=lsigma+modes*ctemp*conjg(ctemp)
           if (idim.eq.0.or.idim.eq.4) then
              lchisq=lchisq+modes*tf*tf
           else
              lchisq=lchisq+modes*tf*tf*akk/3.0
           end if
           ! Fill back buffer with ctemp
#ifdef DOUB
           f(index) = real(ctemp)
           f(index+1) = aimag(ctemp)
#else
           f(index) = real(ctemp,kind=sp)
           f(index+1) = real(aimag(ctemp),kind=sp)
#endif
        enddo
        !  Do k1=n12+1.
        ak1=0.5*akmax
        akk=ak1*ak1+ak23
        ak=sqrt(akk)
        index = int((k3-1)*np2+k2-1,8)*n2p1+np1+1
        !  Evaluate transfer function.
        dq=npow*ak/akmaxf
        if (dq.ge.npow) then
           tf=0.0
        else
           jp=int(dq)
           dq=dq-jp
           tf=(1.0-dq)*tsav(jp)+dq*tsav(jp+1)
        end if
        !  Shift using offsets, with care at the Brillouin zone boundaries.
        theta=0.0
        if (k2.ne.n22+1) theta=theta+ak2*xoff
        if (k3+local_z_start.ne.n32+1) theta=theta+ak3*xoff
        z=cmplx(cos(theta),sin(theta),kind=dpc)
        !  These factors correctly average shifts at the Nyquist planes.
        z=z*cos(ak1*xoff)
        if (k2.eq.n22+1) z=z*cos(ak2*xoff)
        if (k3+local_z_start.eq.n32+1) z=z*cos(ak3*xoff)
        !  Convolve white noise with transfer function.
#ifdef DOUB
        ctemp = cmplx(f(index),f(index+1),kind=dpc)
#else
        ctemp = cmplx(real(f(index),kind=dp),real(f(index+1),kind=dp))
#endif
        ctemp = ctemp*z*tf
        if (idim.eq.1) then
           ctemp=0.0
        else if (idim.eq.2) then
           ctemp=cmplx(0.0,1.0)*ak2*ctemp
           if (k2.eq.n22+1) ctemp=0.0
        else if (idim.eq.3) then
           ctemp=cmplx(0.0,1.0)*ak3*ctemp
           if (k3+local_z_start.eq.n32+1) ctemp=0.0
        end if
        modes=1
        lsigma=lsigma+modes*ctemp*conjg(ctemp)
        if (idim.eq.0.or.idim.eq.4) then
           lchisq=lchisq+modes*tf*tf
        else
           lchisq=lchisq+modes*tf*tf*akk/3.0
        end if
        ! Fill back buffer with ctemp
#ifdef DOUB
        f(index)=real(ctemp)
        f(index+1)=aimag(ctemp)
#else
        f(index)=real(ctemp,kind=sp)
        f(index+1)=real(aimag(ctemp),kind=sp)
#endif
     enddo
  enddo
  call mpi_barrier(mpi_comm_world,ierr)
  !  Enforce zero mean.
  if (local_z_start==0) then
     f(1)=0
     f(2)=0
  endif
  ! Reduce local statistics on root proc
  !print*,'lchisq = ',lchisq
  !print*,'lsigma = ',lsigma
  call mpi_reduce(lchisq,chisq,1,mpi_double_precision,mpi_sum,0,mpi_comm_world,ierr)
  call mpi_reduce(lsigma,sigma,1,mpi_double_precision,mpi_sum,0,mpi_comm_world,ierr)


  chisq=sqrt(chisq)
  sigma=sqrt(sigma)
  !      Transform to position space.

  call fft_mpi(iplan,f,total_local_size)
  lfm=0.0
  do i3=1,local_nz
     do i2=1,np2
        do i1=1,np1
           index=int((i3-1)*np2+i2-1,8)*n2p1+i1
#ifdef DOUB
           lfm=max(lfm,abs(f(index)))
#else
           lfm=max(lfm,real(abs(f(index)),kind=dp))
#endif
        end do
     end do
  end do
  ! Reduce max on root proc
  call mpi_reduce(lfm,fm,1,mpi_real,mpi_max,0,mpi_comm_world,ierr)
  if (myid==0) then
     print*,'Statistics of ic4 for idim, itide=',idim,itide
     write(*,'(a,3f15.5)') &
          & '   Mean sigma, sampled sigma, maximum=',real(chisq), &
          &    real(sigma),fm
  endif
  return
end subroutine mpic4

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!   Copyright (C) 2008-2019 by Simon Prunet, Christophe Pichon et al     !
!   prunet iap.fr                                                        !
!                                                                        !
!   This program is free software; you can redistribute it and/or modify !
!   it under the terms of the GNU General Public License as published by !
!   the Free Software Foundation; either version 2 of the License, or    !
!   (at your option) any later version.                                  !
!                                                                        !
!   This program is distributed in the hope that it will be useful,      !
!   but WITHOUT ANY WARRANTY; without even the implied warranty of       !
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        !
!   GNU General Public License for more details.                         !
!                                                                        !
!   You should have received a copy of the GNU General Public License    !
!   along with this program; if not, write to the                        !
!   Free Software Foundation, Inc.,                                      !
!     59 Temple Place - Suite 330, Boston, MA  02111-1307, USA           !
!   or see https://www.gnu.org/licenses/licenses.html#GPL .              !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module grafic_types
#ifdef HAVE_USE_MPI_F08
  use mpi_f08
#endif
  integer, parameter :: dp=selected_real_kind(12,200)
  integer, parameter :: sp=selected_real_kind(5,30)
  ! TODO: portability - "kind parameters are implementation dependent" -
  ! https://gcc.gnu.org/onlinedocs/gcc-6.3.0/gfortran/Old-style-kind-specifications.html
  ! possible solution - https://gcc.gnu.org/onlinedocs/gcc-6.3.0/gfortran/C_005fSIZEOF.html
  integer, parameter :: sp_bytes = 4

  integer, parameter :: i4b=selected_int_kind(9)
  integer, parameter :: i8b=selected_int_kind(18) !log(2*10^18)/log(2)=60.8
  integer, parameter :: dpc=kind((1.0_dp,1.0_dp))

  REAL(kind=dp), PARAMETER, public :: PI=3.141592653589793238462643383279502884197_dp

  ! FFTW stuff
  INTEGER,PARAMETER:: FFTW_FORWARD=-1, FFTW_BACKWARD=1

  INTEGER,PARAMETER:: FFTW_REAL_TO_COMPLEX=-1, FFTW_COMPLEX_TO_REAL=1

  INTEGER,PARAMETER:: FFTW_ESTIMATE=0, FFTW_MEASURE=1

  INTEGER,PARAMETER:: FFTW_OUT_OF_PLACE=0, FFTW_IN_PLACE=8

  INTEGER,PARAMETER:: FFTW_USE_WISDOM=16

  INTEGER,PARAMETER:: FFTW_THREADSAFE=128

  integer,parameter:: FFTW_TRANSPOSED_ORDER=1, FFTW_NORMAL_ORDER=0
  integer,parameter:: FFTW_SCRAMBLED_INPUT=8192
  integer,parameter:: FFTW_SCRAMBLED_OUTPUT=16384

#ifdef ADD1US
#define  rfftw3d_f77_create_plan  rfftw3d_f77_create_plan_
#define  rfftwnd_f77_destroy_plan rfftwnd_f77_destroy_plan_
#define  rfftwnd_f77_one_real_to_complex rfftwnd_f77_one_real_to_complex_
#define  rfftw3d_f77_mpi_create_plan  rfftw3d_f77_mpi_create_plan_
#define  rfftwnd_f77_mpi_destroy_plan rfftwnd_f77_mpi_destroy_plan_
#define  rfftwnd_f77_mpi rfftwnd_f77_mpi_
#define  rfftwnd_f77_mpi_local_sizes rfftwnd_f77_mpi_local_sizes_
#endif

#ifndef HAVE_USE_MPI_F08
  INCLUDE 'mpif.h'
#endif

end module grafic_types

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!   Copyright (C) 2008-2019 by Simon Prunet, Christophe Pichon et al     !
!   prunet iap.fr                                                        !
!                                                                        !
!   This program is free software; you can redistribute it and/or modify !
!   it under the terms of the GNU General Public License as published by !
!   the Free Software Foundation; either version 2 of the License, or    !
!   (at your option) any later version.                                  !
!                                                                        !
!   This program is distributed in the hope that it will be useful,      !
!   but WITHOUT ANY WARRANTY; without even the implied warranty of       !
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        !
!   GNU General Public License for more details.                         !
!                                                                        !
!   You should have received a copy of the GNU General Public License    !
!   along with this program; if not, write to the                        !
!   Free Software Foundation, Inc.,                                      !
!     59 Temple Place - Suite 330, Boston, MA  02111-1307, USA           !
!   or see https://www.gnu.org/licenses/licenses.html#GPL .              !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!=======================================================================
!
!   P A R A L L E L   R A N D O M   N U M B E R   G E N E R A T O R
!
!=======================================================================
! Here's how to use these functions:
!       Initialization: call Rans( N, StartVal, Seeds )
! This returns an array of M seeds, where M = N if N is odd, or N+1
! otherwise; the returned seeds have values that partition the basic
! ranf cycle of 2**46 pseudorandom reals in [0,1] into independent sub-
! sequences. The second argument, StartVal, can be a cycle-starting seed
! for the full-period generator; if it is zero, a special seed will be
! used that produces statistically desirable behavior.
!       Use: call Ranf( Seed, RandNum )
! This returns a pseudorandom real and a seed to be passed back in the
! next invocation. The returned seed carries the state normally hidden
! in imperative generators.
!=======================================================================

!TODO: (kind=8) is not portable - replace this by a portable version

#include "../config.h"

module random
  use iso_C_binding

  integer(c_int32_t),parameter :: MaxParallelism = 65536 !!! TO BE INCREASED IF NEEDED!
  integer(c_int32_t),parameter :: MaxRandNumStreams = MaxParallelism
  integer,parameter :: IRandNumSize = 4, IBinarySize = 48
  integer,parameter :: Mod4096DigitSize = 12
  !integer,parameter :: IAmountofParallelism = 128
  integer,parameter :: IZero = 0
  integer,parameter :: NPoissonLimit = 10

  integer,dimension( IRandNumSize ) :: &
       & Multiplier = (/373, 3707, 1442, 647/)
  integer,dimension( IRandNumSize ) :: &
       & DefaultSeed = (/ 3281, 4041, 595, 2376 /)
  real(kind=8),dimension( IRandNumSize ) :: &
       & Divisor = (/281474976710656.0,68719476736.0,16777216.0,4096.0/)

  integer :: IGauss = 0
  real(kind=8) :: GaussBak = 0.0d0

contains
  !=======================================================================
  subroutine ranf( Seed, RandNum )
    implicit none
    integer,dimension( IRandNumSize ) :: Seed
    real(kind=8) :: RandNum

    integer,dimension( IRandNumSize ) :: OutSeed

    RandNum = float( Seed( 4 ) ) / Divisor( 4 ) + &
         &    float( Seed( 3 ) ) / Divisor( 3 ) + &
         &    float( Seed( 2 ) ) / Divisor( 2 ) + &
         &    float( Seed( 1 ) ) / Divisor( 1 )

    call ranfmodmult( Multiplier, Seed, OutSeed )

    Seed = OutSeed

    return
  end subroutine ranf
  !=======================================================================

  !=======================================================================
  subroutine poissdev( Seed, AverNum , PoissNum)
    implicit none
    integer,dimension( IRandNumSize ) :: Seed
    real(kind=8) :: AverNum
    integer :: PoissNum

    real(kind=8) :: Norm, Repar, Proba
    real(kind=8) :: RandNum, GaussNum

    if(AverNum <= DBLE(NPoissonLimit)) then
       Norm=exp(-AverNum)
       Repar=1.0d0
       PoissNum=0
       Proba=1.0d0
       call ranf(Seed,RandNum)
       do while(Repar*Norm <= RandNum .and. PoissNum <= 10*NPoissonLimit )
          PoissNum=PoissNum+1
          Proba=Proba*AverNum/PoissNum
          Repar=Repar+Proba
       end do
    else
       call gaussdev(Seed,GaussNum)
       GaussNum=GaussNum*sqrt(AverNum)-0.5+AverNum
       if(GaussNum<=0.0d0)GaussNum=0.0d0
       PoissNum=nint(GaussNum)
    endif

    return
  end subroutine poissdev
  !=======================================================================

  !=======================================================================
  subroutine gaussdev( Seed, GaussNum )
    implicit none
    integer,dimension( IRandNumSize ) :: Seed
    real(kind=8) :: GaussNum

    real(kind=8) :: fac,rsq,v1,v2

    if (IGauss.eq.IZero) then
       rsq=0.0d0
       do while (rsq.ge.1.0d0.or.rsq.le.0.0d0)
          call ranf(Seed,v1)
          call ranf(Seed,v2)
          v1=2.0d0*v1-1.0d0
          v2=2.0d0*v2-1.0d0
          rsq=v1**2+v2**2
       end do
       fac=sqrt(-2.0d0*log(rsq)/rsq)
       GaussBak=v1*fac
       GaussNum=v2*fac
       IGauss=1
    else
       GaussNum=GaussBak
       IGauss=0
    endif
    return
  END subroutine gaussdev
  !=======================================================================

  !=======================================================================
  subroutine rans( NIn, StartVal, SeedArray )
    implicit none
    integer :: NIn
    integer :: StartVal
    integer,dimension( MaxRandNumStreams, IRandNumSize ) :: SeedArray

    integer,dimension( IRandNumSize ) :: atothek
    integer,dimension( IRandNumSize ) :: K
    integer,dimension( IRandNumSize ) :: InSeed
    integer,dimension( IRandNumSize ) :: OutSeed
    integer,dimension( IBinarySize )  :: KBinary

    integer :: N, I

    if( mod(NIn,2) .eq. 1 ) then
       N = NIn
    else
       N = NIn + 1
    endif

    if( StartVal .eq. IZero ) then
       SeedArray( 1, 1 ) = DefaultSeed( 1 )
       SeedArray( 1, 2 ) = DefaultSeed( 2 )
       SeedArray( 1, 3 ) = DefaultSeed( 3 )
       SeedArray( 1, 4 ) = DefaultSeed( 4 )
    else
       SeedArray( 1, 1 ) = abs( StartVal )
       SeedArray( 1, 2 ) = IZero
       SeedArray( 1, 3 ) = IZero
       SeedArray( 1, 4 ) = IZero
    endif

    if( N .eq. 1 ) then
       atothek( 1 ) = Multiplier( 1 )
       atothek( 2 ) = Multiplier( 2 )
       atothek( 3 ) = Multiplier( 3 )
       atothek( 4 ) = Multiplier( 4 )
    else
       call ranfk( N, K )
       call ranfkbinary( K, KBinary )
       call ranfatok( Multiplier, KBinary, atothek )
       do I = 2, N
          InSeed( 1 ) = SeedArray( I-1, 1 )
          InSeed( 2 ) = SeedArray( I-1, 2 )
          InSeed( 3 ) = SeedArray( I-1, 3 )
          InSeed( 4 ) = SeedArray( I-1, 4 )
          call ranfmodmult( InSeed, atothek, OutSeed )
          SeedArray( I, 1 ) = OutSeed( 1 )
          SeedArray( I, 2 ) = OutSeed( 2 )
          SeedArray( I, 3 ) = OutSeed( 3 )
          SeedArray( I, 4 ) = OutSeed( 4 )
       end do
    endif

    return
  end subroutine rans
  !=======================================================================

  !=======================================================================
  subroutine ranfatok( a, Kbinary, atothek )
    implicit none
    integer,dimension( IRandNumSize ) :: a
    integer,dimension( IBinarySize )  :: KBinary
    integer,dimension( IRandNumSize ) :: atothek

    integer,dimension( IRandNumSize ) :: asubi

    integer :: I
    asubi( 1 ) = a( 1 )
    asubi( 2 ) = a( 2 )
    asubi( 3 ) = a( 3 )
    asubi( 4 ) = a( 4 )

    atothek( 1 ) = 1
    atothek( 2 ) = IZero
    atothek( 3 ) = IZero
    atothek( 4 ) = IZero

    do I = 1, 45
       if( KBinary( I ) .ne. IZero ) then
          call ranfmodmult( atothek, asubi, atothek )
       endif
       call ranfmodmult( asubi, asubi, asubi )
    end do

    return
  end subroutine ranfatok
  !=======================================================================

  !=======================================================================
  subroutine ranfk( N, K )
    implicit none
    integer :: N
    integer, dimension( IRandNumSize ) :: K

    integer :: nn, r4, r3, r2, q4, q3, q2, q1

    nn = N + iranfeven( N )

    q4 = 1024 / nn
    r4 = 1024 - (nn * q4)
    q3 = (r4 * 4096) / nn
    r3 = (r4 * 4096) - (nn * q3)
    q2 = (r3 * 4096) / nn
    r2 = (r3 * 4096) - (nn * q2)
    q1 = (r2 * 4096) / nn

    K( 1 ) = q1
    K( 2 ) = q2
    K( 3 ) = q3
    K( 4 ) = q4

    return
  end subroutine ranfk
  !=======================================================================

  !=======================================================================
  subroutine ranfkbinary( K, KBinary )
    implicit none
    integer, dimension( IRandNumSize ) :: K
    integer, dimension( IBinarySize ) ::  KBinary

    integer, dimension( Mod4096DigitSize ) :: Bits
    integer X, I, J

    do I = 1, 4
       X = K( I ) / 2
       Bits( 1 ) = iranfodd( K( I ) )
       do J = 2, Mod4096DigitSize
          Bits( J ) = iranfodd( X )
          X = X / 2
       end do
       do J = 1, Mod4096DigitSize
          KBinary( (I-1)*Mod4096DigitSize + J ) = Bits( J )
       end do
    end do

    return
  end subroutine ranfkbinary
  !=======================================================================

  !=======================================================================
  subroutine ranfmodmult( A, B, C )
    implicit none
    integer, dimension( IRandNumSize ) :: A, B, C

    integer :: j1, j2, j3, j4, k1, k2, k3, k4

    j1 = A( 1 ) * B( 1 )
    j2 = A( 1 ) * B( 2 ) + A( 2 ) * B( 1 )
    j3 = A( 1 ) * B( 3 ) + A( 2 ) * B( 2 ) + A( 3 ) * B( 1 )
    j4 = A( 1 ) * B( 4 ) + A( 2 ) * B( 3 ) + A( 3 ) * B( 2 ) + A( 4 ) * B( 1 )

    k1 = j1
    k2 = j2 + k1 / 4096
    k3 = j3 + k2 / 4096
    k4 = j4 + k3 / 4096

    C( 1 ) = mod( k1, 4096 )
    C( 2 ) = mod( k2, 4096 )
    C( 3 ) = mod( k3, 4096 )
    C( 4 ) = mod( k4, 4096 )

    return
  end subroutine ranfmodmult
  !=======================================================================

  !=======================================================================
  function iranfodd( N )
    integer N
    if( mod( N, 2 ) .eq. 0 ) then
       iranfodd = 0
    else
       iranfodd = 1
    endif

    return
  end function iranfodd
  !=======================================================================
  !=======================================================================
  function iranfeven( N )
    integer N
    if( mod( N, 2 ) .eq. 0 ) then
       iranfeven = 1
    else
       iranfeven = 0
    endif
    return
  end function iranfeven
  !=======================================================================

end module random

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!   Copyright (C) 2008-2019 by Simon Prunet, Christophe Pichon et al     !
!   prunet iap.fr                                                        !
!                                                                        !
!   This program is free software; you can redistribute it and/or modify !
!   it under the terms of the GNU General Public License as published by !
!   the Free Software Foundation; either version 2 of the License, or    !
!   (at your option) any later version.                                  !
!                                                                        !
!   This program is distributed in the hope that it will be useful,      !
!   but WITHOUT ANY WARRANTY; without even the implied warranty of       !
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        !
!   GNU General Public License for more details.                         !
!                                                                        !
!   You should have received a copy of the GNU General Public License    !
!   along with this program; if not, write to the                        !
!   Free Software Foundation, Inc.,                                      !
!     59 Temple Place - Suite 330, Boston, MA  02111-1307, USA           !
!   or see https://www.gnu.org/licenses/licenses.html#GPL .              !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#include "../config.h"

module grafic_io

  use grafic_types
  implicit none
!  integer, parameter :: nblock = 10
  integer, parameter :: RECORD_FLAG=4 !bytes

  type taille
     integer :: nx
     integer :: ny
     integer :: nz
     real(kind=sp) :: dx
     real(kind=sp) :: lx
     real(kind=sp) :: ly
     real(kind=sp) :: lz
  end type taille

  type cosmo
     real(kind=sp) :: astart
     real(kind=sp) :: omegam
     real(kind=sp) :: omegav
     real(kind=sp) :: h0
  end type cosmo

  interface grafic_write
     module procedure grafic_write_single, grafic_write_double
  end interface

  interface grafic_read
     module procedure grafic_read_single, grafic_read_double
  end interface

  ! TODO: When c_off_t becomes available and standard, use this
  ! together with AC_SYS_LARGEFILE in configure.ac to get 64-bit
  ! file offsets; change int64_t to off_t in parallel_io.c too.
  interface
     subroutine f77_parallel_read &
          (filename, fnamelen, size, offset, buffer_address)
       use iso_C_binding
       implicit none
       character(len=128) :: filename
       integer(c_int32_t) :: fnamelen
       integer(c_size_t) :: size ! size_t = unsigned long, cf pread(), pwrite()
       integer(c_int64_t) :: offset
       type(c_ptr), value :: buffer_address
     end subroutine f77_parallel_read
  end interface

  interface
     subroutine f77_parallel_write &
          (filename, fnamelen, size, offset, buffer_address)
       use iso_C_binding
       implicit none
       character(len=128) :: filename
       integer(c_int32_t) :: fnamelen
       integer(c_size_t) :: size
       integer(c_int64_t) :: offset
       type(c_ptr), value :: buffer_address
     end subroutine f77_parallel_write
  end interface

contains


  ! This routine write a fftw_mpi slice of a cube
  ! This slice has interior dimension nx, exterior nz.
  ! Beware that interior dimension is padded: nx <- 2(nx/2+1)
  ! Padded region will not be written.
  subroutine grafic_write_double(buffer,local_nz,local_z_start,ny,nx,filename,padding_in, white_in)
    use iso_C_binding
#ifdef HAVE_USE_MPI_F08
    use mpi_f08
#endif

    ! Arguments
    implicit none
#ifndef HAVE_USE_MPI_F08
    include 'mpif.h'
#endif
    real(dp), dimension(:), intent(in) :: buffer
    integer, intent(in) :: local_nz, local_z_start, ny, nx
    character(len=128), intent(in) :: filename
    !integer, intent(in) :: filenamelen
    logical, optional :: padding_in
    logical, optional :: white_in

    ! Local variables
    !real(sp), allocatable, dimension(:) :: tampon
    !integer :: record_size
    !integer(RECORD_FLAG) :: taille_tampon ! kind values are implementation dependent!

    real(c_float), allocatable, dimension(:), target :: tampon
    integer(c_int32_t), target :: taille_tampon

    integer :: n2x
    integer(i8b) :: index, index2, offset
    integer(c_size_t) length !, toto
    !integer :: idummy=0
    integer :: i,j,k !,myid,ierr
    logical :: padding, white

    padding=.false.
    white=.false.
    if (present(padding_in)) padding = padding_in
    !if (present(padding_in)) write(*,*) 'padding is on'
    if (present(white_in)) white = white_in
    ! 2*4 for leading and trailing record sizes
    n2x = 2*(nx/2+1)
    if (padding) then
       !write(*,*) 'padding is true in grafic_write'
       allocate(tampon(ny*n2x))
       taille_tampon = ny*n2x*sp_bytes ! in bytes
    else
       allocate(tampon(ny*nx))
       taille_tampon = ny*nx*sp_bytes ! in bytes
    endif

    if (white) then
       offset = 4*4 + 2*RECORD_FLAG
    else
       offset = 3*4+8*sp_bytes + 2*RECORD_FLAG ! First record
    endif

    if (padding) then
       offset = offset + local_z_start*int(ny*n2x*sp_bytes + 2*RECORD_FLAG, i8b)
    else
       offset = offset + local_z_start*int(ny*nx*sp_bytes + 2*RECORD_FLAG, i8b)
    endif

    do k=1,local_nz

       index2=1
       ! This loop to (eventually) get rid of fftw padding zone
       if (padding) then
       do j=1,ny
          do i=1,n2x
             index = ((k-1)*ny+j-1)*n2x+i
             tampon(index2) = real(buffer(index),kind=sp)
             index2 = index2 + 1
          enddo
       enddo
       else
          do j=1,ny
             do i=1,nx
                index = ((k-1)*ny+j-1)*n2x+i
                tampon(index2) = real(buffer(index),kind=sp)
                index2 = index2 + 1
             enddo
          enddo
       endif
       ! First write f... Fortran record length
       length=RECORD_FLAG
       call f77_parallel_write(trim(filename),len_trim(filename, i4b), length &
            & ,offset,c_loc(taille_tampon))
       offset = offset+RECORD_FLAG
       if (padding) then
          length = ny*n2x*sp_bytes
       else
          length = ny*nx*sp_bytes
       endif
       call f77_parallel_write(trim(filename),len_trim(filename, i4b), length, &
            & offset, c_loc(tampon))
       offset = offset+length
       ! Again ..
       length=RECORD_FLAG
       call f77_parallel_write(trim(filename),len_trim(filename, i4b), length &
            & ,offset,c_loc(taille_tampon))
       offset = offset+RECORD_FLAG

    enddo
    deallocate(tampon)

  end subroutine grafic_write_double

  subroutine grafic_write_single(buffer,local_nz,local_z_start,ny,nx,filename,padding_in, white_in)
    use iso_C_binding
#ifdef HAVE_USE_MPI_F08
    use mpi_f08
#endif

    ! Arguments
    implicit none
#ifndef HAVE_USE_MPI_F08
    include 'mpif.h'
#endif
    real(sp), dimension(:), intent(in) :: buffer
    integer, intent(in) :: local_nz, local_z_start, ny, nx
    character(len=128), intent(in) :: filename
    !integer, intent(in) :: filenamelen
    logical, optional :: padding_in
    logical, optional :: white_in


    ! Local variables
    !real(sp), allocatable, dimension(:) :: tampon
    !integer :: record_size
    !integer(RECORD_FLAG) :: taille_tampon

    real(c_float), allocatable, dimension(:), target :: tampon
    integer(c_int32_t), target :: taille_tampon

    integer :: n2x
    integer(i8b) :: index, index2, offset
    integer(c_size_t) :: length !, toto
    !integer :: idummy=0
    integer :: i,j,k !,myid,ierr
    logical :: padding, white


    padding=.false.
    white=.false.
    if (present(padding_in)) padding = padding_in
    !if (present(padding_in)) write(*,*) 'padding is on'
    if (present(white_in)) white = white_in
    ! 2*4 for leading and trailing record sizes
    n2x = 2*(nx/2+1)
    if (padding) then
       !write(*,*) 'padding is true in grafic_write'
       allocate(tampon(ny*n2x))
       taille_tampon = ny*n2x*sp_bytes ! in bytes
    else
       allocate(tampon(ny*nx))
       taille_tampon = ny*nx*sp_bytes ! in bytes
    endif

    if (white) then
       offset = 4*4 + 2*RECORD_FLAG
    else
       offset = 3*4+8*sp_bytes + 2*RECORD_FLAG ! First record
    endif

    if (padding) then
       offset = offset + local_z_start*int(ny*n2x*sp_bytes + 2*RECORD_FLAG, i8b)
    else
       offset = offset + local_z_start*int(ny*nx*sp_bytes + 2*RECORD_FLAG, i8b)
    endif

    do k=1,local_nz

       index2=1
       ! This loop to (eventually) get rid of fftw padding zone
       if (padding) then
       do j=1,ny
          do i=1,n2x
             index = ((k-1)*ny+j-1)*n2x+i
             tampon(index2) = real(buffer(index),kind=sp)
             index2 = index2 + 1
          enddo
       enddo
       else
          do j=1,ny
             do i=1,nx
                index = ((k-1)*ny+j-1)*n2x+i
                tampon(index2) = real(buffer(index),kind=sp)
                index2 = index2 + 1
             enddo
          enddo
       endif
       ! First write f... Fortran record length
       length=RECORD_FLAG
       call f77_parallel_write(trim(filename),len_trim(filename, i4b), length &
            & ,offset,c_loc(taille_tampon))
       offset = offset+RECORD_FLAG
       if (padding) then
          length = ny*n2x*sp_bytes
       else
          length = ny*nx*sp_bytes
       endif
       call f77_parallel_write(trim(filename),len_trim(filename, i4b), length, &
            & offset, c_loc(tampon))
       offset = offset+length
       ! Again ..
       length=RECORD_FLAG
       call f77_parallel_write(trim(filename),len_trim(filename, i4b), length &
            & ,offset,c_loc(taille_tampon))
       offset = offset+RECORD_FLAG

    enddo
    deallocate(tampon)

  end subroutine grafic_write_single

  subroutine grafic_read_double(buffer,local_nz,local_z_start,ny,nx,filename, padding_in, white_in)

    use iso_C_binding
#ifdef HAVE_USE_MPI_F08
    use mpi_f08
#endif

    ! Arguments
    implicit none
#ifndef HAVE_USE_MPI_F08
    include 'mpif.h'
#endif
    integer, intent(in) :: local_nz, local_z_start, ny, nx
    real(dp), dimension(local_nz*ny*2*(nx/2+1)), intent(out) :: buffer
    character(len=128), intent(in) :: filename
    logical, optional :: padding_in ! Read padded zone or not
    logical, optional :: white_in ! Different header for white noise file
    ! Local variables
    !real(sp), allocatable, dimension(:) :: tampon
    !integer :: record_size
    !integer(RECORD_FLAG) :: taille_tampon ! kind values are implementation dependent!

    real(c_float), allocatable, dimension(:), target :: tampon
    integer(c_int32_t), target :: taille_tampon

    integer :: n2x
    integer(i8b) :: index, index2, offset
    integer(c_size_t) :: length
    !integer :: idummy=0
    integer :: i,j,k
    !integer :: myid,ierr
    logical :: padding
    logical :: white


    padding = .false.
    white = .false.
    if (present(padding_in)) padding = padding_in
    if (present(white_in)) white = white_in
    ! 2*4 for leading and trailing record sizes
    n2x = 2*(nx/2+1)
    if (padding) then
       allocate(tampon(ny*n2x))
    else
       allocate(tampon(ny*nx))
    endif
    taille_tampon = 0

    if (white) then
       offset = 4*4 + 2*RECORD_FLAG
    else
       offset = 3*4+8*sp_bytes + 2*RECORD_FLAG ! First record
    endif
    if (padding) then
       offset = offset + local_z_start*int(ny*n2x*sp_bytes + 2*RECORD_FLAG, i8b)
    else
       offset = offset + local_z_start*int(ny*nx*sp_bytes+2*RECORD_FLAG, i8b)
    endif

    do k=1,local_nz

       length = RECORD_FLAG
       ! First read f... Fortran record length
       call f77_parallel_read(trim(filename),len_trim(filename, i4b), length &
            & ,offset,c_loc(taille_tampon))
       if (padding) then
           if (taille_tampon /= ny*n2x*sp_bytes) then
             print*,'Record size ',taille_tampon,' is different from expected', &
                  & ny*n2x*sp_bytes
             stop
          endif
       else
           if (taille_tampon /= ny*nx*sp_bytes) then
             print*,'Record size ',taille_tampon,' is different from expected', &
                  & ny*nx*sp_bytes
             stop
          endif
       endif
       offset = offset+RECORD_FLAG

       if (padding) then
          length = ny*n2x*sp_bytes
       else
          length = ny*nx*sp_bytes
       endif
       call f77_parallel_read(trim(filename),len_trim(filename, i4b), length, &
            & offset, c_loc(tampon))
       offset = offset+length
       ! Again ..
       length=RECORD_FLAG
       call f77_parallel_read(trim(filename),len_trim(filename, i4b), length &
            & ,offset,c_loc(taille_tampon))
       offset = offset+RECORD_FLAG

       ! This loop to (eventually) get rid of fftw padding zone
       index2=1
       if (padding) then
          do j=1,ny
             do i=1,n2x ! Read padding (Nyquist) : reading in k space ...
                index=((k-1)*ny+j-1)*n2x+i
                buffer(index) = real(tampon(index2),kind=dp)
                index2 = index2 + 1
             enddo
          enddo
       else
          do j=1,ny
             do i=1,nx ! Do not read padding : reading in real space ...
                index = ((k-1)*ny+j-1)*n2x+i
                buffer(index) = real(tampon(index2),kind=dp)
                index2 = index2 + 1
             enddo
          enddo
       endif

    enddo
    deallocate(tampon)

  end subroutine grafic_read_double

  subroutine grafic_read_single(buffer,local_nz,local_z_start,ny,nx,filename, padding_in, white_in)
    use iso_C_binding
#ifdef HAVE_USE_MPI_F08
    use mpi_f08
#endif

    ! Arguments
    implicit none
#ifndef HAVE_USE_MPI_F08
    include 'mpif.h'
#endif
    integer, intent(in) :: local_nz, local_z_start, ny, nx
    real(sp), dimension(local_nz*ny*2*(nx/2+1)), intent(out) :: buffer
    character(len=128), intent(in) :: filename
    logical, optional :: padding_in ! Read padded zone or not
    logical, optional :: white_in ! Different header for white noise file
    ! Local variables
    !real(sp), allocatable, dimension(:) :: tampon
    !integer :: record_size
    !integer(RECORD_FLAG) :: taille_tampon

    real(c_float), allocatable, dimension(:), target :: tampon
    integer(c_int32_t), target :: taille_tampon

    integer :: n2x
    integer(i8b) :: index, index2, offset
    integer(c_size_t) :: length
    !integer :: idummy=0
    integer :: i,j,k
    !integer :: myid,ierr
    logical :: padding
    logical :: white


    padding = .false.
    white = .false.
    if (present(padding_in)) padding = padding_in
    if (present(white_in)) white = white_in
    ! 2*4 for leading and trailing record sizes
    n2x = 2*(nx/2+1)
    if (padding) then
       allocate(tampon(ny*n2x))
    else
       allocate(tampon(ny*nx))
    endif
    taille_tampon = 0

    if (white) then
       offset = 4*4 + 2*RECORD_FLAG
    else
       offset = 3*4+8*sp_bytes + 2*RECORD_FLAG ! First record
    endif
    if (padding) then
       offset = offset + local_z_start*int(ny*n2x*sp_bytes + 2*RECORD_FLAG, i8b)
    else
       offset = offset + local_z_start*int(ny*nx*sp_bytes+2*RECORD_FLAG, i8b)
    endif

    do k=1,local_nz

       length = RECORD_FLAG
       ! First read f... Fortran record length
       call f77_parallel_read(trim(filename),len_trim(filename, i4b), length &
            & ,offset,c_loc(taille_tampon))
       if (padding) then
           if (taille_tampon /= ny*n2x*sp_bytes) then
             print*,'Record size ',taille_tampon,' is different from expected', &
                  & ny*n2x*sp_bytes
             stop
          endif
       else
           if (taille_tampon /= ny*nx*sp_bytes) then
             print*,'Record size ',taille_tampon,' is different from expected', &
                  & ny*nx*sp_bytes
             stop
          endif
       endif
       offset = offset+RECORD_FLAG

       if (padding) then
          length = ny*n2x*sp_bytes
       else
          length = ny*nx*sp_bytes
       endif
       call f77_parallel_read(trim(filename),len_trim(filename, i4b), length, &
            & offset, c_loc(tampon))
       offset = offset+length
       ! Again ..
       length=RECORD_FLAG
       call f77_parallel_read(trim(filename),len_trim(filename, i4b), length &
            & ,offset,c_loc(taille_tampon))
       offset = offset+RECORD_FLAG

       ! This loop to (eventually) get rid of fftw padding zone
       index2=1
       if (padding) then
          do j=1,ny
             do i=1,n2x ! Read padding (Nyquist) : reading in k space ...
                index=((k-1)*ny+j-1)*n2x+i
                buffer(index) = real(tampon(index2),kind=sp)
                index2 = index2 + 1
             enddo
          enddo
       else
          do j=1,ny
             do i=1,nx ! Do not read padding : reading in real space ...
                index = ((k-1)*ny+j-1)*n2x+i
                buffer(index) = real(tampon(index2),kind=sp)
                index2 = index2 + 1
             enddo
          enddo
       endif

    enddo
    deallocate(tampon)

  end subroutine grafic_read_single




  subroutine grafic_read_header(filename,head_taille,head_cosmo)

    type(taille), intent(out) :: head_taille
    type(cosmo), intent(out) :: head_cosmo
    character(len=128), intent(in) :: filename
    logical :: ok

    inquire(file=filename,exist=ok)
    if (.not. ok) then
       print*,'File ',trim(filename),' does not exist, aborting.'
       stop
    endif

    open(2,file=filename,form='unformatted',status='old')
    read(2) head_taille%nx, head_taille%ny, head_taille%nz, head_taille%dx, &
         head_taille%lx, head_taille%ly, head_taille%lz, head_cosmo%astart, &
         head_cosmo%omegam, head_cosmo%omegav, head_cosmo%h0
    close(2)

  end subroutine grafic_read_header

  subroutine grafic_read_header_white(filename,nx,ny,nz,iseed)

    use iso_C_binding
    integer, intent(out) :: nx,ny,nz
#ifdef HAVE_LIBGSL
    integer(c_int64_t), intent(out) :: iseed
#else
    integer, intent(out) :: iseed
#endif

    character(len=128), intent(in) :: filename
    logical :: ok

    inquire(file=filename,exist=ok)
    if (.not. ok) then
       print*,'File ',trim(filename),' does not exist, aborting.'
       stop
    endif

    open(2,file=filename,form='unformatted',status='old')
    read(2) nx, ny, nz, iseed
    close(2)

  end subroutine grafic_read_header_white

  subroutine grafic_write_header(filename,head_taille,head_cosmo)

    type(taille), intent(in) :: head_taille
    type(cosmo), intent(in) :: head_cosmo
    character(len=128), intent(in) :: filename

    open(2,file=filename,form='unformatted',status='unknown')
    write(2) head_taille%nx, head_taille%ny, head_taille%nz, head_taille%dx, &
         head_taille%lx, head_taille%ly, head_taille%lz, head_cosmo%astart, &
         head_cosmo%omegam, head_cosmo%omegav, head_cosmo%h0
    close(2)

  end subroutine grafic_write_header

  subroutine grafic_write_header_white(filename,nx,ny,nz,iseed)

    use iso_C_binding
    integer, intent(in) :: nx,ny,nz
#ifdef HAVE_LIBGSL
    integer(c_int64_t), intent(in) :: iseed
#else
    integer, intent(in) :: iseed
#endif
    character(len=128), intent(in) :: filename

    open(2,file=filename,form='unformatted',status='unknown')
    write(2) nx, ny, nz, iseed
    close(2)

  end subroutine grafic_write_header_white


end module grafic_io

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!   Copyright (C) 2008-2019 by Simon Prunet, Christophe Pichon et al     !
!   prunet iap.fr                                                        !
!                                                                        !
!   This program is free software; you can redistribute it and/or modify !
!   it under the terms of the GNU General Public License as published by !
!   the Free Software Foundation; either version 2 of the License, or    !
!   (at your option) any later version.                                  !
!                                                                        !
!   This program is distributed in the hope that it will be useful,      !
!   but WITHOUT ANY WARRANTY; without even the implied warranty of       !
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        !
!   GNU General Public License for more details.                         !
!                                                                        !
!   You should have received a copy of the GNU General Public License    !
!   along with this program; if not, write to the                        !
!   Free Software Foundation, Inc.,                                      !
!     59 Temple Place - Suite 330, Boston, MA  02111-1307, USA           !
!   or see https://www.gnu.org/licenses/licenses.html#GPL .              !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!*****************************************************************************
function p(ak,a)
  !  p evaluates the power spectrum at wavenumber ak for expansion factor a.
  !  It takes the nearest transfer function and scales it to a using the
  !  cdm transfer function.
  !  N.B. p is the 3-D spectral density and has units of 1/(ak*ak*ak).
  !  N.B. ak has units of 1/Mpc, _not_ h/Mpc.

  parameter (nkmax=1000,nt=11)
  double precision atab(nt)
  double precision y(nkmax,nt),dy(nkmax,nt),dk,akminl
  double precision y1(nkmax,nt),dy1(nkmax,nt)
  double precision y2(nkmax,nt),dy2(nkmax,nt)
  real dplus,f_baryon,omhh
  !     integer dummy
  common /cosmoparms/ omegam,omegav,h0
  common /cosmoparms2/ omegab,omegahdm,degen_hdm
  common /pstuff/ atab,an,pnorm,icase,ilog,ntab
  common /splin2/ y,dy,y1,dy1,y2,dy2,dk,akminl,nk
  common /scaling/ a00,a10,scale
  common /extwarn/ iwarn1,iwarn2


  if (ak.le.0.0) then
     p=0.0
     return
  end if
  omega=omegam+omegav
  !**************************************
  !  Scale-free case.
  if (icase.eq.3) then
     if (a10.ne.a.or.a00.ne.1.0) then
        a10=a
        a00=1.0
        scale=dplus(a,omegam,omegav)/dplus(1.0,omegam,omegav)
     end if
     p=pnorm*(scale**2)*(ak**an)
     return
  end if
  !**************************************
  !  Transfer function case.  The transfer function T(k) is defined so
  !  that for initial curvature perturbations, phi(k,a=1)=T(k)*psi(k,a=0)
  !  where psi(k,a=0) has power spectrum pnorm*ak**(an-4) and phi(k,a=1)
  !  is related to delta (actually, Bardeens gauge-invariant variable
  !  epsilon_m) by the Poisson equation.  For isocurvature initial
  !  conditions, linger uses the initial entropy perturbation rather than
  !  psi for normalization, but everything in this subroutine and in pini
  !  below follows without  change.
  !  Two subcases: BBKS transfer function or tabulated transfer function
  !  from linger.dat.
  if (icase.eq.2) then
     !**************************************
     !  Use fit to matter transfer function.
     !  Hubble constant in units of 100 km/sec/Mpc.
     h=h0/100.0
     !!omegab=0.039
     omegahh=omegam*h*h !!*exp(-omegab*(1.+sqrt(h/0.5)/omegam))
     q=ak/omegahh
     !  Transfer function for cold dark matter (from BBKS).
     a1=2.34*q
     a2=3.89*q
     a3=16.1*q
     a4=5.46*q
     a5=6.71*q
     t=1.0+a2+a3*a3+a4*a4*a4+a5*a5*a5*a5
     t=log(1.0+a1)/a1/sqrt(sqrt(t))
     !  Transfer function for cold dark matter (90%) plus baryons (10%)
     !  (from Holtzman).
     !        if (h.eq.0.5) then
     !  Commented out 10% baryons.
     !           a1=-1.323
     !           a2=29.12
     !           a3=50.29
     !           a4=57.39
     !  These are for 5% baryons.
     !      a1=-.9876
     !      a2=26.27
     !      a3=43.51
     !      a4=50.45
     !        else
     !    if (h.ne.1.0) write(*,*) 'Assuming H0=100!'
     !  Commented out 10% baryons.
     !           a1=-.8282
     !           a2=9.184
     !           a3=4.806
     !           a4=4.666
     !      a1=-.4306
     !      a2=6.505
     !      a3=4.040
     !      a4=3.337
     !        endif
     !        t=1.0/(1.0+a2*ak+sqrt(ak)*(a1+a3*ak)+a4*ak*ak)
     !  Transfer function for cold dark matter (from DEFW).
     !  a1=1.7*q
     !  a2=4.327*q
     !  a3=1.0*q
     !  t=1.0/(1.0+a1+a2*sqrt(a2)+a3*a3)
     !  Transfer function for hot dark matter (from BBKS).
     !  a1=2.6*q
     !  a2=1.6*q
     !  a3=4.0*q
     !  a4=0.92*q
     !  t=exp(-0.16*a1-0.5*a1*a1)/(1.0+a2+a3*sqrt(a3)+a4*a4)
     !  Apply transfer function to primordial power spectrum.
     !  Primordial spectrum of psi (or entropy, in the isocurvature case):
     p=pnorm*ak**(an-4.0)
     !  Apply transfer function to get spectrum of phi at a=1.
     p=p*t*t
     !  Convert to density fluctuation power spectrum.  Note that k^2 is
     !  corrected for an open universe.  Scale to a using linear theory.
     tpois=-(2.0d0/3.0d0)/omegam*((ak*2.99793e5/h0)**2 &
          & -4.*(omega-1.0))
     if (a10.ne.a.or.a00.ne.1.0) then
        a10=a
        a00=1.0
        scale=dplus(a,omegam,omegav)/dplus(1.0,omegam,omegav)
     end if
     p=p*tpois*tpois*scale**2
     return

     !***************************************************************
     !************EISENSTEIN AND HU POWER SPECTRUM*****************
     !***************************************************************
  elseif (icase.eq.4) then
     !**************************************
     !  Use fit to matter transfer function.
     !  Hubble constant in units of 100 km/sec/Mpc.
     h=h0/100.0
     ! Transfer function with Baryonic Wiggles
     omhh = omegam*h*h
     f_baryon=omegab/omegam
     t=TFmdm_onek_mpc(ak,omhh,f_baryon)


     !  Apply transfer function to primordial power spectrum.
     !  Primordial spectrum of psi (or entropy, in the isocurvature case):
     p=pnorm*ak**(an-4.0)
     !  Apply transfer function to get spectrum of phi at a=1.
     p=p*t*t
     !  Convert to density fluctuation power spectrum.  Note that k^2 is
     !  corrected for an open universe.  Scale to a using linear theory.
     tpois=-(2.0d0/3.0d0)/omegam*((ak*2.99793e5/h0)**2 &
          -4.*(omega-1.0))
     if (a10.ne.a.or.a00.ne.1.0) then
        a10=a
        a00=1.0
        scale=dplus(a,omegam,omegav)/dplus(1.0,omegam,omegav)
     end if
     p=p*tpois*tpois*scale**2
     return
     !
  else
     !**************************************
     !  Use tabulated matter transfer function.
     !  Find the first tabulated value exceeding a.
     itt=0
     do it=1,ntab
        if (itt.eq.0.and.atab(it).gt.a) then
           itt=it
        end if
     end do
     if (itt.eq.0) itt=ntab
     if (itt.eq.1) itt=2
     dt=log(a/atab(itt-1))/log(atab(itt)/atab(itt-1))
     if (ilog.eq.0) then
        d=ak/dk
        i=d
        d=d-i
        if (i.lt.1) then
           if (iwarn1.eq.0) then
              iwarn1=1
              write(*,*) 'Warning: extrapolating k below kmin of linger.dat'
              write(*,*) '         ak,akmin=',ak,dk
           end if
           t1=y(1,itt-1)
           t2=y(1,itt)
        else if (i.ge.nk) then
           if (iwarn2.eq.0) then
              iwarn2=1
              write(*,*) 'Warning: extrapolating k beyond kmax of linger.dat'
              write(*,*) '         ak,akmax=',ak,nk*dk
           end if
           dltdlk=log(y(nk,itt-1)/y(nk-1,itt-1))/log(nk/(nk-1.0))
           dlk=log(ak/(nk*dk))
           t1=y(nk,itt-1)*exp(dltdlk*dlk)
           dltdlk=log(y(nk,itt)/y(nk-1,itt))/log(nk/(nk-1.0))
           dlk=log(ak/(nk*dk))
           t2=y(nk,itt)*exp(dltdlk*dlk)
        else
           t1=y(i,itt-1)+d*(dy(i,itt-1)+d*(3.0*(y(i+1,itt-1)-y(i,itt-1)) &
                &       -2.0*dy(i,itt-1)-dy(i+1,itt-1)+d*(dy(i,itt-1)+dy(i+1,itt-1) &
                &       +2.0*(y(i,itt-1)-y(i+1,itt-1)))))
           t2=y(i,itt)+d*(dy(i,itt)+d*(3.0*(y(i+1,itt)-y(i,itt)) &
                &       -2.0*dy(i,itt)-dy(i+1,itt)+d*(dy(i,itt)+dy(i+1,itt) &
                &       +2.0*(y(i,itt)-y(i+1,itt)))))
        end if
     else
        akl=log(ak)
        d=(akl-akminl)/dk+1
        i=d
        d=d-i
        if (i.lt.1) then
           if (iwarn1.eq.0) then
              iwarn1=1
              write(*,*) 'Warning: extrapolating k below kmin of linger.dat'
              write(*,*) '         ak,akmin=',ak,exp(akminl)
           end if
           t1=y(1,itt-1)
           t2=y(1,itt)
        else if (i.ge.nk) then
           if (iwarn2.eq.0) then
              iwarn2=1
              write(*,*) 'Warning: extrapolating k beyond kmax of linger.dat'
              write(*,*) '         ak,akmax=',ak,exp(akminl+(nk-1)*dk)
           end if
           dltdi=log(y(nk,itt-1)/y(nk-1,itt-1))
           t1=y(nk,itt-1)*exp(dltdi*(d+i-nk))
           dltdi=log(y(nk,itt)/y(nk-1,itt))
           t2=y(nk,itt)*exp(dltdi*(d+i-nk))
        else
           t1=y(i,itt-1)+d*(dy(i,itt-1)+d*(3.0*(y(i+1,itt-1)-y(i,itt-1)) &
                &       -2.0*dy(i,itt-1)-dy(i+1,itt-1)+d*(dy(i,itt-1)+dy(i+1,itt-1) &
                &       +2.0*(y(i,itt-1)-y(i+1,itt-1)))))
           t2=y(i,itt)+d*(dy(i,itt)+d*(3.0*(y(i+1,itt)-y(i,itt)) &
                &       -2.0*dy(i,itt)-dy(i+1,itt)+d*(dy(i,itt)+dy(i+1,itt) &
                &       +2.0*(y(i,itt)-y(i+1,itt)))))
        end if
     end if
     t=(t1**(1.0-dt))*(t2**dt)
     !  Apply transfer function to primordial power spectrum.
     !  Primordial spectrum of psi (or entropy, in the isocurvature case):
     p=pnorm*ak**(an-4.0)
     !  Apply transfer function to get density fluctuation spectrum at a.
     p=p*t*t
     return
  end if
  !
end function p
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
function pcdm(ak,a)
  !  p evaluates the cdm power spectrum at wavenumber ak for expansion factor a.
  !  It takes the nearest transfer function and scales it to a using the
  !  cdm transfer function.
  !  N.B. p is the 3-D spectral density and has units of 1/(ak*ak*ak).
  !  N.B. ak has units of 1/Mpc, _not_ h/Mpc.
  !
  parameter (nkmax=1000,nt=11)
  double precision atab(nt)
  double precision y(nkmax,nt),dy(nkmax,nt),dk,akminl
  double precision y1(nkmax,nt),dy1(nkmax,nt)
  double precision y2(nkmax,nt),dy2(nkmax,nt)
  common /cosmoparms/ omegam,omegav,h0
  common /pstuff/ atab,an,pnorm,icase,ilog,ntab
  common /splin2/ y1,dy1,y,dy,y2,dy2,dk,akminl,nk
  common /scaling/ a00,a10,scale
  common /extwarn/ iwarn1,iwarn2

  if (ak.le.0.0) then
     pcdm=0.0
     return
  end if
  !**************************************
  !  Scale-free case.
  if (icase.eq.3) then
     pcdm=p(ak,a)
     return
  else if (icase.eq.2.or.icase.eq.4) then
     !**************************************
     !  Transfer function case.  The transfer function T(k) is defined so
     !  that for initial curvature perturbations, phi(k,a=1)=T(k)*psi(k,a=0)
     !  where psi(k,a=0) has power spectrum pnorm*ak**(an-4) and phi(k,a=1)
     !  is related to delta (actually, Bardeens gauge-invariant variable
     !  epsilon_m) by the Poisson equation.  For isocurvature initial
     !  conditions, linger uses the initial entropy perturbation rather than
     !  psi for normalization, but everything in this subroutine and in pini
     !  below follows without  change.
     !  Two subcases: BBKS transfer function or tabulated transfer function
     !  from linger.dat.
     !**************************************
     pcdm=p(ak,a)
     return
  end if
  !  Use tabulated matter transfer function.
  !  First the first tabulated value exceeding a.
  itt=0
  do it=1,ntab
     if (itt.eq.0.and.atab(it).gt.a) then
        itt=it
     end if
  end do
  if (itt.eq.0) itt=ntab
  if (itt.eq.1) itt=2
  dt=log(a/atab(itt-1))/log(atab(itt)/atab(itt-1))
  if (ilog.eq.0) then
     d=ak/dk
     i=d
     d=d-i
     if (i.lt.1) then
        if (iwarn1.eq.0) then
           iwarn1=1
           write(*,*) 'Warning: extrapolating k below kmin of linger.dat'
           write(*,*) '         ak,akmin=',ak,dk
        end if
        t1=y(1,itt-1)
        t2=y(1,itt)
     else if (i.ge.nk) then
        if (iwarn2.eq.0) then
           iwarn2=1
           write(*,*) 'Warning: extrapolating k beyond kmax of linger.dat'
           write(*,*) '         ak,akmax=',ak,nk*dk
        end if
        dltdlk=log(y(nk,itt-1)/y(nk-1,itt-1))/log(nk/(nk-1.0))
        dlk=log(ak/(nk*dk))
        t1=y(nk,itt-1)*exp(dltdlk*dlk)
        dltdlk=log(y(nk,itt)/y(nk-1,itt))/log(nk/(nk-1.0))
        dlk=log(ak/(nk*dk))
        t2=y(nk,itt)*exp(dltdlk*dlk)
     else
        t1=y(i,itt-1)+d*(dy(i,itt-1)+d*(3.0*(y(i+1,itt-1)-y(i,itt-1)) &
             &       -2.0*dy(i,itt-1)-dy(i+1,itt-1)+d*(dy(i,itt-1)+dy(i+1,itt-1) &
             &       +2.0*(y(i,itt-1)-y(i+1,itt-1)))))
        t2=y(i,itt)+d*(dy(i,itt)+d*(3.0*(y(i+1,itt)-y(i,itt)) &
             &       -2.0*dy(i,itt)-dy(i+1,itt)+d*(dy(i,itt)+dy(i+1,itt) &
             &       +2.0*(y(i,itt)-y(i+1,itt)))))
     end if
  else
     akl=log(ak)
     d=(akl-akminl)/dk+1
     i=d
     d=d-i
     if (i.lt.1) then
        if (iwarn1.eq.0) then
           iwarn1=1
           write(*,*) 'Warning: extrapolating k below kmin of linger.dat'
           write(*,*) '         ak,akmin=',ak,exp(akminl)
        end if
        t1=y(1,itt-1)
        t2=y(1,itt)
     else if (i.ge.nk) then
        if (iwarn2.eq.0) then
           iwarn2=1
           write(*,*) 'Warning: extrapolating k beyond kmax of linger.dat'
           write(*,*) '         ak,akmax=',ak,exp(akminl+(nk-1)*dk)
        end if
        dltdi=log(y(nk,itt-1)/y(nk-1,itt-1))
        t1=y(nk,itt-1)*exp(dltdi*(d+i-nk))
        dltdi=log(y(nk,itt)/y(nk-1,itt))
        t2=y(nk,itt)*exp(dltdi*(d+i-nk))
     else
        t1=y(i,itt-1)+d*(dy(i,itt-1)+d*(3.0*(y(i+1,itt-1)-y(i,itt-1)) &
             &       -2.0*dy(i,itt-1)-dy(i+1,itt-1)+d*(dy(i,itt-1)+dy(i+1,itt-1) &
             &       +2.0*(y(i,itt-1)-y(i+1,itt-1)))))
        t2=y(i,itt)+d*(dy(i,itt)+d*(3.0*(y(i+1,itt)-y(i,itt)) &
             &       -2.0*dy(i,itt)-dy(i+1,itt)+d*(dy(i,itt)+dy(i+1,itt) &
             &       +2.0*(y(i,itt)-y(i+1,itt)))))
     end if
  end if
  t=(t1**(1.0-dt))*(t2**dt)
  !  Apply transfer function to primordial power spectrum.
  !  Primordial spectrum of psi (or entropy, in the isocurvature case):
  pcdm=pnorm*ak**(an-4.0)
  !  Apply transfer function to get density fluctuation spectrum at a.
  pcdm=pcdm*t*t
  return

end function pcdm
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
function pbar(ak,a)
  !  p evaluates the bar power spectrum at wavenumber ak for expansion factor a=1.
  !  N.B. p is the 3-D spectral density and has units of 1/(ak*ak*ak).
  !  N.B. ak has units of 1/Mpc, _not_ h/Mpc.

  parameter (nkmax=1000,nt=11)
  double precision atab(nt)
  double precision y(nkmax,nt),dy(nkmax,nt),dk,akminl
  double precision y1(nkmax,nt),dy1(nkmax,nt)
  double precision y2(nkmax,nt),dy2(nkmax,nt)
  common /cosmoparms/ omegam,omegav,h0
  common /pstuff/ atab,an,pnorm,icase,ilog,ntab
  common /splin2/ y1,dy1,y2,dy2,y,dy,dk,akminl,nk
  common /scaling/ a00,a10,scale
  common /extwarn/ iwarn1,iwarn2

  if (ak.le.0.0) then
     pbar=0.0
     return
  end if
  !**************************************
  !  Scale-free case.
  if (icase.eq.3) then
     pbar=p(ak,a)
     return
  else if (icase.eq.2.or.icase.eq.4) then
     !**************************************
     !  Transfer function case.  The transfer function T(k) is defined so
     !  that for initial curvature perturbations, phi(k,a=1)=T(k)*psi(k,a=0)
     !  where psi(k,a=0) has power spectrum pnorm*ak**(an-4) and phi(k,a=1)
     !  is related to delta (actually, Bardeens gauge-invariant variable
     !  epsilon_m) by the Poisson equation.  For isocurvature initial
     !  conditions, linger uses the initial entropy perturbation rather than
     !  psi for normalization, but everything in this subroutine and in pini
     !  below follows without  change.
     !  Two subcases: BBKS transfer function or tabulated transfer function
     !  from linger.dat.
     !**************************************
     pbar=p(ak,a)
     return
  end if
  !  Use tabulated matter transfer function.
  !  First the first tabulated value exceeding a.
  itt=0
  do it=1,ntab
     if (itt.eq.0.and.atab(it).gt.a) then
        itt=it
     end if
  end do
  if (itt.eq.0) itt=ntab
  if (itt.eq.1) itt=2
  dt=log(a/atab(itt-1))/log(atab(itt)/atab(itt-1))
  if (ilog.eq.0) then
     d=ak/dk
     i=d
     d=d-i
     if (i.lt.1) then
        if (iwarn1.eq.0) then
           iwarn1=1
           write(*,*) 'Warning: extrapolating k below kmin of linger.dat'
           write(*,*) '         ak,akmin=',ak,dk
        end if
        t1=y(1,itt-1)
        t2=y(1,itt)
     else if (i.ge.nk) then
        if (iwarn2.eq.0) then
           iwarn2=1
           write(*,*) 'Warning: extrapolating k beyond kmax of linger.dat'
           write(*,*) '         ak,akmax=',ak,nk*dk
        end if
        dltdlk=log(y(nk,itt-1)/y(nk-1,itt-1))/log(nk/(nk-1.0))
        dlk=log(ak/(nk*dk))
        t1=y(nk,itt-1)*exp(dltdlk*dlk)
        dltdlk=log(y(nk,itt)/y(nk-1,itt))/log(nk/(nk-1.0))
        dlk=log(ak/(nk*dk))
        t2=y(nk,itt)*exp(dltdlk*dlk)
     else
        t1=y(i,itt-1)+d*(dy(i,itt-1)+d*(3.0*(y(i+1,itt-1)-y(i,itt-1)) &
             &       -2.0*dy(i,itt-1)-dy(i+1,itt-1)+d*(dy(i,itt-1)+dy(i+1,itt-1) &
             &       +2.0*(y(i,itt-1)-y(i+1,itt-1)))))
        t2=y(i,itt)+d*(dy(i,itt)+d*(3.0*(y(i+1,itt)-y(i,itt)) &
             &       -2.0*dy(i,itt)-dy(i+1,itt)+d*(dy(i,itt)+dy(i+1,itt) &
             &       +2.0*(y(i,itt)-y(i+1,itt)))))
     end if
  else
     akl=log(ak)
     d=(akl-akminl)/dk+1
     i=d
     d=d-i
     if (i.lt.1) then
        if (iwarn1.eq.0) then
           iwarn1=1
           write(*,*) 'Warning: extrapolating k below kmin of linger.dat'
           write(*,*) '         ak,akmin=',ak,exp(akminl)
        end if
        t1=y(1,itt-1)
        t2=y(1,itt)
     else if (i.ge.nk) then
        if (iwarn2.eq.0) then
           iwarn2=1
           write(*,*) 'Warning: extrapolating k beyond kmax of linger.dat'
           write(*,*) '         ak,akmax=',ak,exp(akminl+(nk-1)*dk)
        end if
        dltdi=log(y(nk,itt-1)/y(nk-1,itt-1))
        t1=y(nk,itt-1)*exp(dltdi*(d+i-nk))
        dltdi=log(y(nk,itt)/y(nk-1,itt))
        t2=y(nk,itt)*exp(dltdi*(d+i-nk))
     else
        t1=y(i,itt-1)+d*(dy(i,itt-1)+d*(3.0*(y(i+1,itt-1)-y(i,itt-1)) &
             &       -2.0*dy(i,itt-1)-dy(i+1,itt-1)+d*(dy(i,itt-1)+dy(i+1,itt-1) &
             &       +2.0*(y(i,itt-1)-y(i+1,itt-1)))))
        t2=y(i,itt)+d*(dy(i,itt)+d*(3.0*(y(i+1,itt)-y(i,itt)) &
             &       -2.0*dy(i,itt)-dy(i+1,itt)+d*(dy(i,itt)+dy(i+1,itt) &
             &       +2.0*(y(i,itt)-y(i+1,itt)))))
     end if
  end if
  t=(t1**(1.0-dt))*(t2**dt)
  !  Apply transfer function to primordial power spectrum.
  !  Primordial spectrum of psi (or entropy, in the isocurvature case):
  pbar=pnorm*ak**(an-4.0)
  !  Apply transfer function to get density fluctuation spectrum at a.
  pbar=pbar*t*t
  return

end function pbar


!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
subroutine pini(infile_id)
#ifdef HAVE_USE_MPI_F08
  use mpi_f08
#endif

  integer :: infile_id

  !  Pini initializes the power spectrum.
  !parameter (pi=3.1415926535898d0)
  double precision, parameter :: pi=3.1415926535898d0
  double precision, parameter :: fourpi=4.0d0*pi !, twopi=2.0d0*pi
  character*128 filename
  parameter (nkmax=1000,nt=11)
  double precision atab(nt)
  double precision deltat2(0:nkmax),ddeltat2(0:nkmax)
  double precision tmat(nkmax,nt),dtmat(nkmax,nt)
  double precision tcdm(nkmax,nt),dtcdm(nkmax,nt)
  double precision tbar(nkmax,nt),dtbar(nkmax,nt)
  double precision rombin,dphid,tcon0,arec,ak,om,ov,ok,uj2
  double precision dc2,dc2l,dk,akmax,akminl,akmaxl,dk1,akmin1
  double precision dsig8,grhom,grhog,grhor,grho,adotoa
  real tcon,dplus
  real tcmb, anorml
  integer myid,ierr
  common /cosmoparms/ omegam,omegav,h0
  common /cosmoparms2/ omegab,omegahdm,degen_hdm
  common /pstuff/ atab,an,pnorm,icase,ilog,ntab
  common /omegas/ om,ov,ok
  common /phint/ tcon0,ak
  common /splin1/ deltat2,ddeltat2,dk,akminl
  common /splin2/ tmat,dtmat,tcdm,dtcdm,tbar,dtbar,dk1,akmin1,nk1
  common /scaling/ a00,a10,scale
  common /extwarn/ iwarn1,iwarn2
  external dphid,dc2,dc2l,dsig8
#ifndef HAVE_USE_MPI_F08
  include 'mpif.h'
#endif

  call mpi_comm_rank(mpi_comm_world,myid,ierr)

  iwarn1=0
  iwarn2=0
  a00=0.0
  a10=0.0
  scale=1.0


  if (myid==0) then
     write(*,*) 'Select type of initial power spectrum', &
          &              ' (matter transfer function):'
     write(*,*) '    1 for T(k) from linger.dat'
     write(*,*) '    2 for T(k) from approx. analytical fit (BBKS)'
     write(*,*) '    3 for T(k)=1 (scale-free)' ! TODO: See uninitialised warning below and fix.
     write(*,*) '    4 for T(k) from approx. analytical fit (E&Hu)'
     write(*,*) 'Enter case (1,2,3 or 4) now:'
     read(infile_id,*) icase
     print*, icase
  endif
  call mpi_bcast(icase,1,mpi_integer,0,mpi_comm_world,ierr)
  if (icase.eq.1) then
     if (myid==0) then
        write(*,*) 'Enter linger.dat filename'
        read(infile_id,'(a)') filename
        open(11,file=filename,status='old')
        rewind 11
        read(11,*) omegab,omegac,omegav,omegan
        read(11,*) h0,tcmb,yhe,nnur,nnunr,initfl
        write(*,*) 'Omegab,c,v,n=',omegab,omegac,omegav,omegan
        write(*,*) 'H0,Tcmb,Y,Nnur,Nnunr,initfl=',h0,tcmb,yhe,nnur, &
             &                nnunr,initfl
     endif
     call mpi_bcast(omegab,1,mpi_real,0,mpi_comm_world,ierr)
     call mpi_bcast(omegac,1,mpi_real,0,mpi_comm_world,ierr)
     call mpi_bcast(omegav,1,mpi_real,0,mpi_comm_world,ierr)
     call mpi_bcast(omegan,1,mpi_real,0,mpi_comm_world,ierr)
     call mpi_bcast(h0,1,mpi_real,0,mpi_comm_world,ierr)
     call mpi_bcast(tcmb,1,mpi_real,0,mpi_comm_world,ierr)
     call mpi_bcast(nnur,1,mpi_integer,0,mpi_comm_world,ierr)
     call mpi_bcast(initfl,1,mpi_integer,0,mpi_comm_world,ierr)
     omegam=omegab+omegac+omegan
     om=omegam
     ov=omegav
     ok=1.0d0-om-ov
     !  Energy density constants.
     grhom=3.3379d-11*h0*h0
     grhog=1.4952d-13*tcmb**4
     grhor=3.3957d-14*tcmb**4
     !  Tcmb in micro-K.
     tcmb=tcmb*1.e6
  else if (icase.eq.2.or.icase.eq.3.or.icase.eq.4) then
     tcmb=2.726e6
     if (h0.eq.0) then
        !  These may already have been set through common.
        if (myid==0) then
           write(*,*) 'Enter Omega_m, Omega_v, H0 (km/s/Mpc,', &
                &               ' set H0=1 for scale-free case)'
           read(infile_id,*) omegam,omegav,h0
           write(*,'(3f15.5)') omegam,omegav,h0
        endif
        call mpi_bcast(omegam,1,mpi_real,0,mpi_comm_world,ierr)
        call mpi_bcast(omegav,1,mpi_real,0,mpi_comm_world,ierr)
        call mpi_bcast(h0,1,mpi_real,0,mpi_comm_world,ierr)

        if(icase.eq.4) then
           if (myid==0) then
              write(*,*) 'Enter Omega_b'
              read(infile_id,*) omegab
              write(*,'(f15.5)') omegab
           end if
           call mpi_bcast(omegab,1,mpi_real,0,mpi_comm_world,ierr)
        endif
     end if
     if (myid==0) &
          write(*,'(a,a,3f15.5)')' Initializing power spectrum for Omega_m, ', &
          & 'Omega_v, H0=',omegam,omegav,h0
     om=omegam
     ov=omegav
     ok=1.0d0-om-ov
     ntab=1
     atab(1)=1.0
  else
     if (myid==0) write(*,*) 'Illegal choice.  Aborting'
     call mpi_finalize(ierr)
     stop
  end if


  !
  if (myid==0) then
     write(*,*) 'Enter long-wave spectral index n (scale-invariant', &
          &             ' is n=1)'
     read(infile_id,*) an
     write(*,'(f15.5)') an
  endif
  call mpi_bcast(an,1,mpi_integer,0,mpi_comm_world,ierr)
  !     an=1
  !
  if (myid==0) then
     write(*,*) 'Enter desired normalization at a=1:'
     if (icase.eq.1.or.icase.eq.2.or.icase.eq.4) then
        write(*,*) '  Qrms-ps/micro-K (if > 0) or -sigma_8 (if < 0) = ?'
     else
        write(*,*) '  k^3*P(k) at k=pi = ?'
     end if
     read(infile_id,*) anorml
  endif
  call mpi_bcast(anorml,1,mpi_real,0,mpi_comm_world,ierr)


  !
  !**************************************
  !  Scale-free case.  pnorm is the power at the Nyquist frequency for
  !  a=1 assuming unit transfer function and dx=1.
  if (icase.eq.3) then
     akmax=pi
     pnorm=anorml/akmax**(3.0+an)
     return
  end if
  !**************************************
  !  Transfer function case.  Normalize by CMB quadrupole.
  !  Two subcases: BBKS transfer function or linger.dat.
  !  First, get l=2 CMB transfer function Delta_2(k).
  !**************************************
  if (icase.eq.2.or.icase.eq.4) then
     !  Compute Delta_2(k) using Sachs-Wolfe approximation (including phidot).
     nk=31
     akmin=1.e-5
     akmax=1.e-2
     ilog=1
     dk=log(akmax/akmin)/(nk-1)
     tcon0=tcon(1.0)
     arec=1.0d0/1200.0d0
     f0=dplus(1.0,omegam,omegav)
     frec=dplus(real(arec),omegam,omegav)/arec
     if (myid==0) then
        write(*,*) 'Computing Delta_2(k) using Sachs-Wolfe approxmation'
        write(*,*) 'This may take several minutes.'
     endif
     do ik=1,nk
        ak=akmin*exp((ik-1)*dk)
        phidotint=rombin(dphid,arec,1.0d0,1.0d-4)



        !  Assume isentropic initial fluctuations.  If they are instead
        !  entropy, replace uj2/3 by uj2*2.
        deltat2(ik)=(frec*uj2(ak*2.99793d5/h0,tcon0,ok)/3.0d0 &
             &                  +2.0d0*phidotint)/f0
             !  write(*,'(a4,i4,a2,i4)') 'ik =',ik,' /',nk
     end do
  else
     !**************************************
     !  Use linger.dat for Delta_2(k) and matter (phi) transfer function.
     !  N.B. We are assuming that there are exactly nt timesteps saved for each k.
     ntab=nt
     do i=1,nkmax
        do it=1,nt
           if (myid==0) then
              read(11,*) ik,ak,a1,tcon1,psi,phi,deltac, &
                   & deltab,deltag,deltar,deltan,thetac,thetab,thetag,thetar,thetan, &
                   & shearg,shearr,shearn,econ
           endif
           ! Propagate to other cpus
           call mpi_bcast(ik,1,mpi_integer,0,mpi_comm_world,ierr)
           call mpi_bcast(ak,1,mpi_real8,0,mpi_comm_world,ierr)
           call mpi_bcast(a1,1,mpi_real,0,mpi_comm_world,ierr)
           call mpi_bcast(phi,1,mpi_real,0,mpi_comm_world,ierr)
           call mpi_bcast(deltac,1,mpi_real,0,mpi_comm_world,ierr)
           call mpi_bcast(deltab,1,mpi_real,0,mpi_comm_world,ierr)
           call mpi_bcast(thetac,1,mpi_real,0,mpi_comm_world,ierr)
           call mpi_bcast(thetab,1,mpi_real,0,mpi_comm_world,ierr)
           call mpi_bcast(shearg,1,mpi_real,0,mpi_comm_world,ierr)


           if (ik.ne.i) then
              if (myid==0) write(*,*) &
                   & 'linger.dat is not sorted properly or has ntab.ne.nt!'
              !       write(*,*) 'sort on first column (sort -n linger.dat)',
              !     2                   ' and rerun'
              call mpi_finalize(ierr)
              stop
           end if
           if (i.eq.1) then
              akmin=ak
              atab(it)=a1
           end if
           !  Use last timestep (probably a=1) to get delta_T/T.
           if (it.eq.nt) deltat2(ik)=shearg/2.0d0
           !  Get the matter (phi) transfer function.
           ! TODO: WARNING: grhom, grhog, grhor uninitialised  if icase .eq. 3
           grho=grhom*(om/a1+ok+ov*a1*a1)+(grhog+nnur*grhor)/(a1*a1)
           adotoa=sqrt(grho/3.0d0)
           if (initfl.gt.0) then
              !  Synchronous gauge.  Gauge transformation is given by phi=eta+etatophi.
              !  What we read in as phi actually is eta.  What we read in as thetac
              !  actually is etatophi.
              tmat(ik,it)=phi+thetac
              ! n.b. thetac=0 in our synch. gauge.
              tcdm(ik,it)=deltac
              tbar(ik,it)=deltab+3.0d0*adotoa/(ak*ak)*thetab
           else
              !  Conformal Newtonian gauge.
              tmat(ik,it)=phi
              tcdm(ik,it)=deltac+3.0d0*adotoa/(ak*ak)*thetac
              tbar(ik,it)=deltab+3.0d0*adotoa/(ak*ak)*thetab
           end if
           !  Convert from potential to density transfer function.  Note that k^2
           !  is corrected for an open universe.
           tpois=-(2.0d0/3.0d0)/om*((ak*2.99793e5/h0)**2+4.0d0*ok)
           tmat(ik,it)=a1*tpois*tmat(ik,it)
           !  Correct the photon quadrupole moment to a=1 using the Sachs-Wolfe
           !  formula (if necessary).
           if (it.eq.nt.and.abs(a1-1.0).gt.0.01) then
              if (ik.eq.1) then
                 arec=a1
                 f0=dplus(1.0,omegam,omegav)
              end if
              phidotint=rombin(dphid,arec,1.0d0,1.0d-4)
              deltat2(ik)=deltat2(ik)+2.0d0*phidotint/f0*tmat(ik,it)
           end if
        end do
     end do
     if (myid==0) close(11)
     nk=ik
     akmax=ak
     if (abs(akmax/nk-akmin).le.1.0e-6) then
        !  Linear steps in k.
        ilog=0
        dk=akmax/nk
     else
        !  Logarithmic steps in k.
        ilog=1
        dk=log(akmax/akmin)/(nk-1)
     end if
  end if
  dk1=dk
  nk1=nk
  !**************************************
  !  Now integrate anisotropy to normalize by Qrms-ps.
  call splini
  if (ilog.eq.0) then
     deltat2(0)=0.0d0
     call splder(deltat2,ddeltat2,nk+1)
     qq=5.0d0*fourpi*rombin(dc2,0.0d0,akmax,1.0d-7)
  else
     call splder(deltat2(1),ddeltat2(1),nk)
     akminl=log(akmin)
     akmin1=akminl
     akmaxl=log(akmax)
     qq=5.0d0*fourpi*rombin(dc2l,log(1.0d-6),akmaxl,1.0d-7)
  end if
  !**************************************
  !  pnorm is the primeval amplitude defined by P_psi=pnorm*ak**(an-4)
  !  in the isentropic case.  For isocurvature initial conditions,
  !  replace P_psi by the power spectrum of primeval entropy perturbations.
  akmax=h0/8.0
  do it=1,ntab
     call splder(tmat(1,it),dtmat(1,it),nk)
     call splder(tcdm(1,it),dtcdm(1,it),nk)
     call splder(tbar(1,it),dtbar(1,it),nk)
  end do
  if (anorml.gt.0.0) then
     !**************************************
     !  anorml is Qrms-ps in micro-K.  Compute corresponding sigma8.
     pnorm=(anorml/tcmb)**2/qq
     !  Now integrate density fluctuation to get sigma8.
     sig0=fourpi*rombin(dsig8,0.0d0,akmax,1.0d-7)
     sigma8=sqrt(sig0)
     if (myid==0) write(*,*) 'Linear sigma8=',sigma8
  else
     !**************************************
     !  anorml is -sigma8, the rms linear density fluctuation in a sphere of
     !  radius 8/h Mpc.  Compute corresponding Qrms-ps.
     sigma8=-anorml
     pnorm=1.0
     sig0=fourpi*rombin(dsig8,0.0d0,akmax,1.0d-7)
     pnorm=sigma8**2/sig0
     qrmsps=tcmb*sqrt(pnorm*qq)
     if (myid==0) write(*,'(a,f15.4)') 'Qrms-ps/micro-K=',qrmsps
  end if

  if (myid==0) then
     write(*,*)
     write(*,*) 'I can write the power spectrum of delta_rho/rho', &
          &             ' to disk (power.dat).'
     write(*,*) 'If you would like this, please enter kmin and', &
          &             ' kmax (1/Mpc)'
     write(*,*) 'Enter 0,0 if you don''t want the power spectrum', &
          &             ' written to a file'
     read(infile_id,*) ak1,ak2
     write(*,'(2es15.5)') ak1,ak2
  endif

  call mpi_bcast(ak1,1,mpi_real,0,mpi_comm_world,ierr)
  call mpi_bcast(ak2,1,mpi_real,0,mpi_comm_world,ierr)

  if (ak1.le.0.0.or.ak2.le.0.0) return
  nkplot=201
  dlkp=log(ak2/ak1)/(nkplot-1)

  if (myid==0) then
     open(11,file='power.dat',form='formatted',status='unknown')
     rewind 11
     write(11,*) an,anorml
     do i=1,nkplot
        ak0=ak1*exp((i-1)*dlkp)
        write(11,*) ak0/(h0/100.0),p(ak0,1.0)*(h0/100.0)**3, &
             &                fourpi*ak0*ak0*ak0*p(ak0,1.0)
     end do
     close(11)
  endif

  return
end subroutine pini

!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
function dc2(ak)
  implicit double precision (a-h,o-z)
  parameter (nkmax=1000,nt=11)
  double precision y(0:nkmax),dy(0:nkmax),atab(nt)
  common /splin1/ y,dy,dk,akminl
  real an,pnorm
  common /pstuff/ atab,an,pnorm,icase,ilog,ntab

  if (ak.eq.0.0d0) then
     dc2=0.0d0
     return
  end if

  d=ak/dk
  i=d
  d=d-i

  delt2=y(i)+d*(dy(i)+d*(3.0*(y(i+1)-y(i))-2.0*dy(i) &
       &   -dy(i+1)+d*(dy(i)+dy(i+1)+2.0*(y(i)-y(i+1)))))

  dc2=delt2*delt2*ak**(an-2.0d0)

  return
end function dc2
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
function dc2l(akl)
  implicit double precision (a-h,o-z)
  parameter (nkmax=1000,nt=11)
  double precision y(0:nkmax),dy(0:nkmax),atab(nt)
  common /splin1/ y,dy,dkl,akminl
  real an,pnorm
  common /pstuff/ atab,an,pnorm,icase,ilog,ntab

  ak=exp(akl)

  d=(akl-akminl)/dkl+1
  i=d
  d=d-i

  if (i.lt.1) then
     delt2=y(1)*(ak/exp(akminl))**2
  else
     delt2=y(i)+d*(dy(i)+d*(3.0*(y(i+1)-y(i))-2.0*dy(i) &
          &     -dy(i+1)+d*(dy(i)+dy(i+1)+2.0*(y(i)-y(i+1)))))
  end if

  dc2l=delt2*delt2*ak**(an-1.0d0)

  return
end function dc2l
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
function dphid(a)
  implicit double precision (a-h,o-z)
  real tcon,dplus,fomega,omegam,omegav,h0
  common /cosmoparms/ omegam,omegav,h0
  common /phint/ tcon0,ak

  ok=1.0d0-omegam-omegav
  r=tcon0-tcon(real(a))
  dphid=dplus(real(a),omegam,omegav)/(a*a) &
       &       *(fomega(real(a),omegam,omegav)-1.0d0) &
       &       *uj2(ak*2.99793d5/h0,r,ok)
  return
end function dphid
!ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
function tcon(a)
  !  Evaluate H0*conformal time for FLRW cosmology.
  !  Assume Omegas passed in common to dtconda.
  real tcon,a
  double precision b,rombint,dtconda
  external dtconda

  b=sqrt(a)
  tcon=rombint(dtconda,0.0d0,b,1.0d-8)
  return
end function tcon
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
function dtconda(b)
  !  Omegam := Omega today (a=1) in matter.
  !  Omegav := Omega today (a=1) in vacuum energy.
  !  Omegak := Omega today (a=1) in curvature, Omegak := 1-Omegam-Omegav.
  implicit double precision (a-h,o-z)
  common /omegas/ omegam,omegav,omegak

  a=b*b
  etab=sqrt(omegam+omegav*a*a*a+omegak*a)
  dtconda=2.0d0/etab
  return
end function dtconda
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
function dsig8(ak)
  !  This function calculates the integrand for the normalization of the
  !  power spectrum with Delta = 1 at r = 8 Mpc/h.

  double precision dsig8,ak,x,w
  common /cosmoparms/ omegam,omegav,h0

  if (ak.le.0.0d0) then
     dsig8=0.0d0
     return
  end if
  !  Window function for spherical tophat of radius 8 Mpc/h.
  x=ak*800.0/h0
  w=3.0*(sin(x)-x*cos(x))/(x*x*x)
  dsig8=ak*ak*p(real(ak),1.0)*w*w
  return
end function dsig8
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
function uj2(ak,chi,omegak)
  !  Evaluate the ultra spherical Bessel function j_2(k,chi,omegak), the
  !  generalization of spherical Bessel function to a constant curvature
  !  3-space.  Must have ak in units of H0/c and chi in units of c/H0.

  !  This routine assumes an open or flat universe with omegak >= 0.
  !  While it is easy to evalulate uj2 for a closed universe, this also
  !  requires replacing integrals over k by sums over k.
  !
  implicit double precision (a-h,o-z)

  if (omegak.lt.-1.0d-6) then
     write(*,*) 'Closed universe prohibited in uj2!'
     write(*,*) 'omegak=',omegak
     stop
  else if (omegak.le.1.0d-6) then
     uj2=aj2(ak*chi)
  else
     rc=1.0d0/sqrt(omegak)
     uj2=bj2(ak*rc,chi/rc)
  end if

  return
end function uj2
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!  Evaluate the spherical bessel function j_2(x).
function aj2(x)

  implicit double precision (a-h,o-z)
  parameter (tol=1.0d-16)

  xa=abs(x)
  xx=x*x
  if (xa.lt.1.0d-3) then
     aj0=1.0d0-xx/6.0d0*(1.0d0-xx/20.0d0*(1.0d0-xx/42.0d0 &
          &      *(1.0d0-xx/72.0d0)))
     aj1=(x/3.0d0)*(1.0d0-xx/10.0d0*(1.0d0-xx/28.0d0 &
          &                 *(1.0d0-xx/54.0d0)))
  else
     aj0=sin(x)/x
     aj1=(sin(x)-x*cos(x))/xx
  end if

  !  Use power series expansion for small argument.
  x2=-0.25d0*xx
  if (-x2.lt.0.5d0.or.xa.lt.1.5d0) then
     fact=xx/15.0d0
     sum=1.0d0
     term=1.0d0
     n=0
7    n=n+1
     term=term*x2/(n*(n+2.5d0))
     sum=sum+term
     if (n.lt.10.or.abs(term).gt.tol) go to 7
     if (abs(sum).lt.1.0d-6) then
        write(*,*) 'aj2** x,sum=',x,sum
        go to 9
     end if
     aj2=fact*sum
     return
  end if
  !  Use recurrence relation to get aj2.
9 continue
  aj2=3.0d0*aj1/x-aj0

  return
end function aj2
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
!  Evaluate the ultra spherical bessel function j_2(k,chi).
function bj2(ak,chi)
  !  This is the generalization of the spherical Bessel function to a pseudo
  !  3-sphere (a 3-space of constant negative curvature).  Must have the radial
  !  wavenumber k and coordinate chi be in units of the curvature distance,
  !  sqrt(-1/K).
  !
  implicit double precision (a-h,o-z)
  parameter (tol=1.0d-10)

  if (ak.lt.0.d0.or.chi.lt.0.d0) then
     write(*,*) 'Negative ak, chi prohibited in bj2!'
     stop
  end if

  akk=ak*ak
  ak1=sqrt(1.0d0+akk)
  if (chi.gt.100.0d0) then
     write(*,*) 'r/Rcurv is too large in bj2'
     stop
  end if
  e=exp(chi)
  ei=1.0d0/e
  ch=0.5d0*(e+ei)
  sh=0.5d0*(e-ei)
  ch2=0.5d0*(1.0d0+ch)
  x2=0.5d0*(1.0d0-ch)
  chi2=chi*chi
  if (sh.lt.1.0d-3) then
     sh=chi*(1.0d0+chi2/6.0d0*(1.0d0+chi2/20.0d0*(1.0d0+chi2/42.0d0 &
          &          *(1.0d0+chi2/72.0d0))))
     x2=-0.25d0*chi2*(1.0d0+chi2/12.0d0*(1.0d0+chi2/30.0d0*(1.0d0+ &
          &        chi2/56.0d0*(1.0d0+chi2/90.0d0))))
  end if
  if (sh.ne.0.0d0) cth=ch/sh
  cn=cos(ak*chi)
  sn=sin(ak*chi)
  if (sh.eq.0.0d0) then
     uj0=1.0d0
     ujl1=0.0d0
  else if (ak.eq.0.0d0) then
     uj0=chi/sh
     uj1=(chi*ch-sh)/(sh*sh)
  else
     uj0=sn/(ak*sh)
     uj1=(sn*ch-ak*sh*cn)/(ak*ak1*sh*sh)
  end if

  if (-x2.lt.0.5d0.and.ak*chi.lt.2) then
     !  Use hypergeometric series expansion for small argument.
     fact=sh*ak1/(3.0d0*ch2*sqrt(ch2))
     ak2=sqrt(akk+4.0d0)
     fact=fact*sh*ak2/(5.0d0*ch2)
     sum=1.0d0
     term=1.0d0
     n=0
10   n=n+1
     hn=n-0.5d0
     term=term*x2*(akk+hn*hn)/(n*(hn+3))
     sum=sum+term
     if (n.lt.5.or.abs(term).gt.tol) go to 10
     uj2=fact*sum

  else
     !  Use recurrence relation to get uj2.
     if (sh.eq.0.0d0) then
        uj2=0.0d0
     else
        ak2=sqrt(akk+4.0d0)
        uj2=(3.0d0*cth*uj1-ak1*uj0)/ak2
     end if

  end if
  bj2=uj2

  return
end function bj2
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
function rombin(f,a,b,tol)
  !  Rombint returns the integral from a to b of f(x)dx using Romberg integration.
  !  The method converges provided that f(x) is continuous in (a,b).  The function
  !  f must be double precision and must be declared external in the calling
  !  routine.  tol indicates the desired relative accuracy in the integral.

  parameter (MAXITER=20,MAXJ=5)
  implicit double precision (a-h,o-z)
  dimension g(MAXJ+1)
  external f

  h=0.5d0*(b-a)
  gmax=h*(f(a)+f(b))
  g(1)=gmax
  nint=1
  error=1.0d20
  i=0
10 i=i+1
  if (i.gt.MAXITER.or.(i.gt.9.and.abs(error).lt.tol)) &
       &      go to 40
  !  Calculate next trapezoidal rule approximation to integral.
  g0=0.0d0
  do 20 k=1,nint
     g0=g0+f(a+(k+k-1)*h)
20   continue
     g0=0.5d0*g(1)+h*g0
     h=0.5d0*h
     nint=nint+nint
     jmax=min(i,MAXJ)
     fourj=1.0d0
     do 30 j=1,jmax
        !  Use Richardson extrapolation.
        fourj=4.0d0*fourj
        g1=g0+(g0-g(j))/(fourj-1.0d0)
        g(j)=g0
        g0=g1
30      continue
        if (abs(g0).gt.tol) then
           error=1.0d0-gmax/g0
        else
           error=gmax
        end if
        gmax=g0
        g(jmax+1)=g0
        go to 10
40      rombin=g0
        if (i.gt.MAXITER.and.abs(error).gt.tol) &
             &    write(*,*) 'Rombint failed to converge; integral, error=', &
             &    rombin,error
        return
      end function rombin
     !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
     !                      HERE STARTS THE $&%*§è BARYONIC PHYSICS
     !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


     !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      real function TFmdm_onek_mpc(k,omhh,f_baryon)

       !  Calculate transfer function
       !
       !  Input:
       !         k -- wavenumber in Mpc^{-1}
       !        omhh -- The density of CDM and baryons, in units of critical dens,
       !                multiplied by the square of the Hubble constant, in units
       !                of 100 km/s/Mpc */
       !        f_baryon -- The fraction of baryons to CDM */
       !
       !  Output:
       !         tf_full -- The full fitting formula, eq. (16), for the matter
       !                    transfer function.
       !         tf_baryon -- The baryonic piece of the full fitting formula, eq. 21.
       !         tf_cdm -- The CDM piece of the full fitting formula, eq. 17.
       !
       !       Tcmb -- The temperature of the CMB in Kelvin, 2.728(4) is COBE and is
       !                the default reached by inputing Tcmb=0 -- reset on output. */
       !
       !        theta_cmb,      /* Tcmb in units of 2.7 K */
       !        z_equality,     /* Redshift of matter-radiation equality, really 1+z */
       !        k_equality,     /* Scale of equality, in Mpc^-1 */
       !        z_drag,         /* Redshift of drag epoch */
       !        R_drag,         /* Photon-baryon ratio at drag epoch */
       !        R_equality,     /* Photon-baryon ratio at equality epoch */
       !        sound_horizon,  /* Sound horizon at drag epoch, in Mpc */
       !        k_silk,         /* Silk damping scale, in Mpc^-1 */
       !        alpha_c,        /* CDM suppression */
       !        beta_c,         /* CDM log shift */
       !        alpha_b,        /* Baryon suppression */
       !        beta_b,         /* Baryon envelope shift */

       implicit none


       real y,omhh,obhh,Tcmb,s_tilde,TF_pressureless

       real k,tf_full,tf_baryon,tf_cdm,q,ks
       real theta_cmb,z_equality,k_equality,z_drag,R_drag,R_equality, &
            &       sound_horizon,k_silk,alpha_c,beta_c,alpha_b,beta_b, &
            &        f_baryon,beta_node



       if (f_baryon.le.0) f_baryon=1.e-5

       ! Ugly hack to initialize Tcmb...
       Tcmb=0.0

       if (Tcmb.le.0) Tcmb=2.728
       if (omhh.le.0.0) then
          write(*,*) 'TFset_parameters(): Illegal input'
          stop
       end if


       ! Auxiliary variables
       obhh = omhh*f_baryon
       theta_cmb = Tcmb/2.7

       ! Main variables
       z_equality = 2.50e4*omhh*theta_cmb**(-4.) - 1.D0
       k_equality = 0.0746*omhh*theta_cmb**(-2.)

       z_drag = 0.313*omhh**(-0.419)*(1.+0.607*omhh**(0.674))
       z_drag = 1e0 + z_drag*obhh**(0.238*omhh**(0.223))
       z_drag = 1291e0 * omhh**(0.251)/ &
            &           (1e0 + 0.659*omhh**(0.828)) * z_drag

       R_drag = 31.5*obhh*theta_cmb**(-4.)*1000e0/(1e0 + z_drag)
       R_equality = 31.5*obhh*theta_cmb**(-4.) &
            &                *1000e0/(1e0 + z_equality)

       sound_horizon = 2./3./k_equality*sqrt(6./R_equality)* &
            &       log(( sqrt(1.+R_drag)+sqrt(R_drag+R_equality) ) &
            &       /(1.+sqrt(R_equality)))

       k_silk = 1.6*obhh**(0.52)*omhh**(0.73)*  &
            &           (1e0 + (10.4*omhh)**(-0.95))

       alpha_c = ((46.9*omhh)**(0.670)*(1e0+(32.1*omhh)**(-0.532)))
       alpha_c = alpha_c**(-f_baryon)
       alpha_c = alpha_c*((12.0*omhh)**(0.424)*(1e0 + &
            &             (45.0*omhh)**(-0.582)))**(-f_baryon**3.)


       beta_c = 0.944/(1+(458.*omhh)**(-0.708))
       beta_c = 1.+beta_c*((1.-f_baryon)**((0.395*omhh)**(-0.0266)) &
            &           - 1e0)
       beta_c = 1./beta_c

       y = (1e0+z_equality)/(1e0+z_drag)
       alpha_b = y*(-6.*sqrt(1.+y)+(2.+3.*y)*log((sqrt(1.+y)+1.) &
            &               /(sqrt(1.+y)-1.)))
       alpha_b = 2.07*k_equality*sound_horizon* &
            &            (1.+R_drag)**(-0.75)*alpha_b


       beta_b = 0.5+f_baryon+(3.-2.*f_baryon)* &
            &           sqrt((17.2*omhh)**2.+1e0)

       beta_node = 8.41*omhh**(0.435)

       if (k.le.0) then
          write(*,*) 'TFtransfer_function(): Illegal k'
          stop
       end if


       !  Auxiliary Variables

       q = k/13.41/k_equality
       ks = k*sound_horizon

       !  Main Variables

       tf_cdm = 1./(1.+(ks/5.4)**4.)
       tf_cdm = tf_cdm*TF_pressureless(q,1.,beta_c) + &
            &           (1.-tf_cdm)*TF_pressureless(q,alpha_c,beta_c)


       s_tilde = sound_horizon/(1.+(beta_node/ks)**3.)**(1./3.)
       tf_baryon = TF_pressureless(q,1.,1.)/(1.+(ks/5.2)**2.)
       tf_baryon = tf_baryon + alpha_b/(1.+(beta_b/ks)**3) &
            &                       *exp(-(k/k_silk)**(1.4))
       tf_baryon = tf_baryon *(sin(k*s_tilde)/(k*s_tilde))
       tf_full = f_baryon*tf_baryon + (1-f_baryon)*tf_cdm

       TFmdm_onek_mpc=tf_full;


       return
     end function TFmdm_onek_mpc

     !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

     !       auxiliary function: Pressureless TF

     real function TF_pressureless(q,a,b)

       real q,a,b

       TF_pressureless = Log(exp(1.)+1.8*b*q)
       TF_pressureless = TF_pressureless/(TF_pressureless + &
            &                      (14.2/a + 386/(1.+69.9*q**1.08))*q**2)

       return

     end function TF_pressureless


     !ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!   Copyright (C) 2008-2019 by Simon Prunet, Christophe Pichon et al     !
!   prunet iap.fr                                                        !
!                                                                        !
!   This program is free software; you can redistribute it and/or modify !
!   it under the terms of the GNU General Public License as published by !
!   the Free Software Foundation; either version 2 of the License, or    !
!   (at your option) any later version.                                  !
!                                                                        !
!   This program is distributed in the hope that it will be useful,      !
!   but WITHOUT ANY WARRANTY; without even the implied warranty of       !
!   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        !
!   GNU General Public License for more details.                         !
!                                                                        !
!   You should have received a copy of the GNU General Public License    !
!   along with this program; if not, write to the                        !
!   Free Software Foundation, Inc.,                                      !
!     59 Temple Place - Suite 330, Boston, MA  02111-1307, USA           !
!   or see https://www.gnu.org/licenses/licenses.html#GPL .              !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        function aexp(tauu,omegam,omegav)
!  Evaluate a(tau) for Friedmann-Lemaitre-Robertson-Walker (FLRW) cosmology.
!  (Use tauu here to avoid conflict with function tau.)
!  Omegam := Omega today (a=1) in matter.
!  Omegav := Omega today (a=1) in vacuum energy.
!  dtau := H0*dt/a^2.
        real aexp,tauu,omegam,omegav,tau,eta
        external tau

!  Initial guess: matter-dominated solution.
        aexp=1.0/(1.0-tauu*(sqrt(omegam)-0.25*omegam*tauu))
!  Newton-Raphson iteration.
        niter=0
10        niter=niter+1
          eta=sqrt(omegam/aexp+omegav*aexp*aexp+1.0-omegam-omegav)
          error=(tau(aexp,omegam,omegav)-tauu)*aexp*aexp*eta
          aerr=abs(error)
          rerr=aerr/aexp
          aexp=aexp-error
          if (min(aerr,rerr).gt.1.0d-6.and.niter.lt.10) go to 10
        return
        end
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        function tau(a,omegam,omegav)
!  Evaluate tau(a) (inverse of a(tau)) for FLRW cosmology.
!  Omegam := Omega today (a=1) in matter.
!  Omegav := Omega today (a=1) in vacuum energy.
!  dtau := H0*dt/a^2.
        real tau,a,omegam,omegav
        double precision om,ov,adp,rombint,dtauda
        common /omegas/ om,ov
        external dtauda

        om=omegam
        ov=omegav
        adp=a
        tau=rombint(dtauda,1.0d0,adp,1.0d-8)
        return
        end
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        function dtauda(a)
        implicit double precision (a-h,o-z)
        common /omegas/ omegam,omegav

        eta=sqrt(omegam/a+omegav*a*a+1.0d0-omegam-omegav)
        dtauda=1.0d0/(a*a*eta)
        return
        end
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        function dladt(a,omegam,omegav)
!  Evaluate dln(a)/dtau for FLRW cosmology.
!  Omegam := Omega today (a=1) in matter.
!  Omegav := Omega today (a=1) in vacuum energy.
        real dladt,a,omegam,omegav,eta

        eta=sqrt(omegam/a+omegav*a*a+1.0-omegam-omegav)
!  N.B. eta=a*H/H0, dladt = da/(H0*dtau) where tau is conformal time!
        dladt=a*eta
        return
        end
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        function dplus(a,omegam,omegav)
!  Evaluate D+(a) (linear growth factor) for FLRW cosmology.
!  Omegam := Omega today (a=1) in matter.
!  Omegav := Omega today (a=1) in vacuum energy.
        real dplus,a,omegam,omegav,eta
        double precision om,ov,adp,rombint,ddplus
        common /omegas/ om,ov
        external ddplus

        om=omegam
        ov=omegav
        adp=a
        eta=sqrt(omegam/a+omegav*a*a+1.0-omegam-omegav)
        dplus=eta/a*rombint(ddplus,0.0d0,adp,1.0d-8)
        return
        end
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        function ddplus(a)
        implicit double precision (a-h,o-z)
        common /omegas/ omegam,omegav

        if (a.eq.0.0d0) then
          ddplus=0.0d0
          return
        end if
        eta=sqrt(omegam/a+omegav*a*a+1.0d0-omegam-omegav)
        ddplus=2.5d0/(eta*eta*eta)
        return
        end
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        function adp(dpls,omegam,omegav)
!  Inverts the function dpls=dplus(a,omegam,omegav) for a=adp.
        real adp,dpls,omegam,omegav,dplus,fomega
        external dplus,fomega
!
        if (dpls.eq.0.0) then
          adp=0.0
          return
        end if
!  Initial guess.
        adp=1.0e-3
!  Newton-Raphson iteration.
        niter=0
10        niter=niter+1
          dpls0=dplus(adp,omegam,omegav)
          ddplda=dpls0*fomega(adp,omegam,omegav)/adp
          error=(dpls0-dpls)/ddplda
          adp=adp-error
          aerr=abs(error)
          rerr=aerr/adp
          if (min(aerr,rerr).gt.1.0e-6.and.niter.lt.10) go to 10
        return
        end
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        function fomega(a,omegam,omegav)
!  Evaluate f := dlog[D+]/dlog[a] (logarithmic linear growth rate) for
!  lambda+matter-dominated cosmology.
!  Omega0 := Omega today (a=1) in matter only.  Omega_lambda = 1 - Omega0.
        real fomega,a,omegam,omegav,dplus,eta
        external dplus
!
        if (omegam.eq.1.0.and.omegav.eq.0.0) then
          fomega=1.0
          return
        end if
        omegak=1.0-omegam-omegav
        eta=sqrt(omegam/a+omegav*a*a+omegak)
        fomega=(2.5/dplus(a,omegam,omegav)-1.5*omegam/a-omegak)/(eta*eta)
        return
        end
!cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
        function rombint(f,a,b,tol)
!  Rombint returns the integral from a to b of f(x)dx using Romberg integration.
!  The method converges provided that f(x) is continuous in (a,b).  The function
!  f must be double precision and must be declared external in the calling
!  routine.  tol indicates the desired relative accuracy in the integral.
!
        parameter (MAXITER=100,MAXJ=5)
        implicit double precision (a-h,o-z)
        dimension g(MAXJ+1)
        external f
!
        h=0.5d0*(b-a)
        gmax=h*(f(a)+f(b))
        g(1)=gmax
        nint=1
        error=1.0d20
        i=0
10        i=i+1
          if (i.gt.MAXITER.or.(i.gt.5.and.abs(error).lt.tol)) &
     &      go to 40
!  Calculate next trapezoidal rule approximation to integral.
          g0=0.0d0
            do 20 k=1,nint
            g0=g0+f(a+(k+k-1)*h)
20        continue
          g0=0.5d0*g(1)+h*g0
          h=0.5d0*h
          nint=nint+nint
          jmax=min(i,MAXJ)
          fourj=1.0d0
            do 30 j=1,jmax
!  Use Richardson extrapolation.
            fourj=4.0d0*fourj
            g1=g0+(g0-g(j))/(fourj-1.0d0)
            g(j)=g0
            g0=g1
30        continue
          if (abs(g0).gt.tol) then
            error=1.0d0-gmax/g0
          else
            error=gmax
          end if
          gmax=g0
          g(jmax+1)=g0
        go to 10
40      rombint=g0
        if (i.gt.MAXITER.and.abs(error).gt.tol) &
     &    write(*,*) 'Rombint failed to converge; integral, error, i=', &
     &    rombint,error,i
        return
        end

#!/bin/sh
# regression-test-0.3.7.9.sh - check consistency of mpgrafic behaviour versus v0.3.7.9

#/***************************************************************************
# *   Copyright (C) 2017 Boud Roukema                                       *
# *                                                                         *
# *   This program is free software; you can redistribute it and/or modify  *
# *   it under the terms of the GNU General Public License as published by  *
# *   the Free Software Foundation; either version 2 of the License, or     *
# *   (at your option) any later version.                                   *
# *                                                                         *
# *   This program is distributed in the hope that it will be useful,       *
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# *   GNU General Public License for more details.                          *
# *                                                                         *
# *   You should have received a copy of the GNU General Public License     *
# *   along with this program; if not, write to the                         *
# *   Free Software Foundation, Inc.,                                       *
# *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA              *
# *   or see https://www.gnu.org/licenses/licenses.html#GPL .               *
# **************************************************************************/


printf "Code regression test: does the standard input file generate an\n"
printf "output file identical to that produced by version 0.3.7.9\n"
printf "of mpgrafic? IEEE_UNDERFLOW_FLAG and IEEE_DENORMAL exceptions\n"
printf "are considered acceptable and ignored. Other minor warnings are\n"
printf "ignored too on some systems/implementations.\n\n"

## Run mpgrafic for a tiny number of particles with mpi - the aim is to test
## algorithms and arithmetic, not computer power.

EXPECTED_OUTPUT=${srcdir}/Output.stdout.np32
TMP_OUT=Output.stdout.np32.tmp
TMP_OUT_CLEANED=Output.stdout.np32.tmp.2

## Running openmpi (on Debian) in a chroot jail with a minimal system
## installed will fail if ssh (and rsh, which is not encrypted) are
## absent from the system. Since ssh is not needed for testing on a
## single processor, the default "rsh_agent" can be safely overridden
## by the default shell "sh", but only if the mpirun (e.g. a symbolic link
## to orterun) options follow a known syntax.
##
## If the system is Debian with mpi-default-dev installed, then
## the check can be done as below.
##
## Adding a build dependency on ssh would be unreasonable, since, for
## example, mpi jobs can be run on multi-processor single
## machines. Moreover, it would add an extra burden in terms of
## automatic checking of packages for security issues.
##
## Please add cases for other mpi implementations or GNU/Linux
## distribution systems, or propose a more generic solution.
##
## 2017-08-14: Switch --mca plm_rsh_agent ssh to
## --mca plm_rsh_agent /bin/false - see
##  https://lists.debian.org/debian-science/2015/10/msg00032.html +
##  http://www.open-mpi.de/faq/?category=rsh
## This may enable builds on kfreebsd-(amd64|i386) and does not
## reduce the power of the test: ssh is obviously
## *not* desirable in automated builds of mpgrafic, and is not tested.

##
if [ -r /usr/share/mpi-default-dev/debian_defaults ] ; then
    MPI_IMPL=$(grep ARCH_DEFAULT_MPI_IMPL \
                    /usr/share/mpi-default-dev/debian_defaults | \
                      sed -e 's/ARCH_DEFAULT_MPI_IMPL *= *//' | \
                      tail -n 1) # last evaluation overrides
    if [ "x${MPI_IMPL}" = "xopenmpi" ]; then
        printf "This looks like a debian openmpi system.\n"
        mpirun -n 1 --mca plm_rsh_agent /bin/false \
               ${MPI_ALLOW_RUN_AS_ROOT} \
               ${srcdir}/src/mpgrafic --np=32 ${srcdir}/Input.stdin \
               > ${TMP_OUT}
    else
        printf "Warning: This looks like a debian system, but \n"
        printf "options for ${MPI_IMPL} have not yet been implemented,\n"
        printf "so this test will pass without doing any work.\n"
        exit 0
    fi
else
    if [ "x${HAVE_OPENMPI}" = "x1" ]; then
        printf "This looks like a system with openmpi.\n"
        mpirun -n 1 --mca plm_rsh_agent /bin/false \
               ${MPI_ALLOW_RUN_AS_ROOT} \
               ${srcdir}/src/mpgrafic --np=32 ${srcdir}/Input.stdin \
               > ${TMP_OUT}
    else
        printf "MPI implementation unknown.\n"
        mpirun -n 1 ${srcdir}/src/mpgrafic --np=32 ${srcdir}/Input.stdin > ${TMP_OUT}
    fi
fi

## Ignore known warnings from non-openmpi implementations of mpi:
cat ${TMP_OUT} | \
    grep -v "Warning: Cannot receive number of cores .*Round robin.*startup scheme will be involved" > \
         ${TMP_OUT_CLEANED}


if ( [ -r ${EXPECTED_OUTPUT} ] && [ -r ${TMP_OUT_CLEANED} ] ); then
    LINES_DIFF=$(diff ${EXPECTED_OUTPUT} ${TMP_OUT_CLEANED} | wc -l)
    if [ "x${LINES_DIFF}" = "x0" ] ; then
        printf "A 32^3 mpi run of mpgrafic matched the expected output.\n"
    else
        printf "Warning: A 32^3 mpi run of mpgrafic did not match the expected output.\n"
        exit 1
    fi
else
    printf "Warning: ${EXPECTED_OUTPUT} or ${TMP_OUT_CLEANED} is not found or not readable.\n"
    exit 1
fi
#rm -f ${TMP_OUT}

exit 0
